package sieve.browser;
import java.awt.*;
import java.beans.*;
import sunw.hotjava.bean.*;
public class Browser extends Panel {
  HotJavaSystemState sysState = new HotJavaSystemState();
  HotJavaDocumentStack docStack = new HotJavaDocumentStack();
  AuthenticatorBean authenticator = new AuthenticatorBean();
  String docString = null;
  TextBean textBean = null;
  HotJavaBrowserBean browserBean = null;
  PropertyChangeSupport changes = new PropertyChangeSupport(this);
  public Browser() {
    setLayout(new BorderLayout());
    Panel controlPanel = new Panel();
    controlPanel.setLayout(new FlowLayout(FlowLayout.CENTER, 10, 5));
    Button back = (Button)controlPanel.add(new Button("Back"));
    Button forward = (Button)controlPanel.add(new Button("Forward"));
    textBean = (TextBean)controlPanel.add(new TextBean());
    textBean.addPropertyChangeListener(new PropertyChangeListener() {
      public void propertyChange(PropertyChangeEvent evt) {
	String prop = evt.getPropertyName();
	if ("text".equals(prop)) {
	  setDocumentString((String)evt.getNewValue());	}      }    });
    add("North", controlPanel);
    browserBean = (HotJavaBrowserBean)add("Center", new HotJavaBrowserBean());
    browserBean.addPropertyChangeListener(new PropertyChangeListener() {
      public void propertyChange(PropertyChangeEvent evt) {
	String prop = evt.getPropertyName();
	if ("documentString".equals(prop)) {
	  setDocumentString((String)evt.getNewValue());	}      }    });
    BrowserHL bHL = new BrowserHL();
    bHL.setTarget(browserBean);
    docStack.addBrowserHistoryListener(bHL); 
    StackHL sHL = new StackHL();
    sHL.setTarget(docStack);
    browserBean.addBrowserHistoryListener(sHL); 
    BackActionListener bAL = new BackActionListener();
    bAL.setTarget(docStack);
    back.addActionListener(bAL);
    ForwardActionListener fAL = new ForwardActionListener();
    fAL.setTarget(docStack);
    forward.addActionListener(fAL);  }
  public Dimension getPreferredSize() {
    Dimension currentSize = getSize();
    Dimension minSize = getMinimumSize();
    if (lessThan(currentSize, minSize))
      return minSize;
    else
      return currentSize;  }
  public static boolean lessThan(Dimension lhs, Dimension rhs) {
    if (lhs.width < rhs.width)
      return true;
    else
      return (lhs.height < rhs.height);  }
  Dimension minSize = new Dimension(400, 500); 
  public Dimension getMinimumSize() {
    return minSize;  }
  public void setDocumentString(String newString) {
    String oldDocString = docString;
    if (!(newString.equals(docString))) {
      docString = newString;
      textBean.setText(docString);
      browserBean.setDocumentString(docString);
      changes.firePropertyChange("documentString", oldDocString, 
				 docString);   }  }
  public String getDocumentString() {
    return docString; }
    public void addPropertyChangeListener(PropertyChangeListener l) {
        changes.addPropertyChangeListener(l);    }
    public void removePropertyChangeListener(PropertyChangeListener l) {
        changes.removePropertyChangeListener(l);    }}
class BrowserHL implements sunw.hotjava.bean.BrowserHistoryListener, java.io.Serializable {
    public void setTarget(sunw.hotjava.bean.HotJavaBrowserBean t) {
        target = t;   }
   public void executeHistoryCommand(sunw.hotjava.bean.BrowserHistoryEvent arg0) {
       target.executeHistoryCommand(arg0);    }

    private sunw.hotjava.bean.HotJavaBrowserBean target;}
class StackHL implements sunw.hotjava.bean.BrowserHistoryListener, java.io.Serializable {
    public void setTarget(sunw.hotjava.bean.HotJavaDocumentStack t) {
        target = t;    }
    public void executeHistoryCommand(sunw.hotjava.bean.BrowserHistoryEvent arg0) {
        target.executeHistoryCommand(arg0);   }
    private sunw.hotjava.bean.HotJavaDocumentStack target;}
class BackActionListener implements java.awt.event.ActionListener, java.io.Serializable {
    public void setTarget(sunw.hotjava.bean.HotJavaDocumentStack t) {
        target = t;    }
    public void actionPerformed(java.awt.event.ActionEvent arg0) {
        target.previousDocument();    }
    private sunw.hotjava.bean.HotJavaDocumentStack target; }
class ForwardActionListener implements java.awt.event.ActionListener, java.io.Serializable {
    public void setTarget(sunw.hotjava.bean.HotJavaDocumentStack t) {
        target = t;    }
    public void actionPerformed(java.awt.event.ActionEvent arg0) {
        target.nextDocument();    }
    private sunw.hotjava.bean.HotJavaDocumentStack target;}
