package sieve.nuggets;

import java.awt.*;
import java.awt.event.*;
import sieve.sluice.*;
import sieve.sluice.event.*;
import sieve.sluice.views.*;

// Should probably abstract some of this out and re-use it for
// AttributeViewer...

//**********************************************************************
// this originally extended TableViewApplet. Changed to extend 
// TableViewJComponent, 1-15-98. All other methods same (lwjones)
//********************************************************************** 
public class AttributeViewer extends TableViewJComponent implements TableView,
    TableViewListener {
    TextArea ta = null;

    public AttributeViewer() {
	super();
	setLayout(new BorderLayout());
	ta = new TextArea();
	ta.setEditable(false);
	ta.setText("(Not Connected)");
	ta.setFont(new Font("Monospaced", Font.PLAIN, 10));
	add("Center", ta);
    }

    public void addSourceView(TableView source) throws TooManySourcesException {
	if (this.source != null)
            throw new TooManySourcesException();
        this.source = source;
	reset();
    }

    protected void reset() {
	if (source == null)
	    return;
        try {
	    TableDescriptor td = source.getTableDescriptor();	
	    StringBuffer buf = new StringBuffer();
	    String[] attrs = td.getAttributeNames();
	    if (attrs.length == 0)
		ta.setText("(Table has no attributes)");
	    else {
	    	for (int i = 0; i < attrs.length; i++) {
		    buf.append(getString(attrs[i], 15) + " = " +
		    	td.getAttribute(attrs[i]) + "\n");
	    	}
	    	ta.setText(buf.toString());
	    }
	}
	catch (InterchangeException e) {
	    e.printStackTrace();
	}
    }

    private String getString(String orig, int len) {
	if (orig.length() > len)
	    return orig.substring(0, len);
	else if (orig.length() < len) {
	    StringBuffer buf = new StringBuffer();
	    buf.append(orig);
	    while (buf.length() < len)
		buf.append(" ");
	    return buf.toString();
	}
	return orig;
    }

    public void removeSourceView(TableView source) {
        if (this.source == source) {
            this.source = null;
	    ta.setText("(Not Connected)");
            eventHandler.fireTableViewEvent(new TableViewEvent(this));
        }
    }

    public void tableViewChanged(TableViewEvent event) {
	if (! (event instanceof AppendEvent))
            reset();
        eventHandler.fireTableViewEvent(event);
    }


}

