package sieve.nuggets;

import java.awt.Color;
import java.awt.Point;
import java.awt.Graphics;
import sieve.util.Arrow;

// Used by bar chart
class NamedBin {
    String name = null;
    int    column = -1;
    Color  color = Color.black;
    Point  cp = null;
    Point  lp = null;
 
    public NamedBin(String name, int column) {
        this.name = name;
        this.column = column;
    }
    public NamedBin(String name, int column, Color color) {
	this(name, column);
	this.color = color;
    }

    public String getName() {
	return name;
    }
    public int getColumn() {
	return column;
    }

    public Color getColor() {
	return color;
    }

    // Subclasses should override this if necessary
    public boolean isVisible() {
	return true;
    }

    public void setLegendPoint(Point lp) {
	this.lp = lp;
    }
    public Point getLegendPoint() {
	return lp;
    }

    public void setColumnPoint(Point cp) {
	this.cp = cp;
    }
    public Point getColumnPoint() {
	return cp;
    }

    public void drawArrowLine(Graphics g, int maxHeadWidth) {
	if ((lp != null) && (cp != null) && isVisible()) {
	    g.setColor(color);
	    Arrow.paintArrow(g, lp, cp, 20, Math.min(7, maxHeadWidth));
	}
    }

}

