package sieve.nuggets;
 
import java.applet.*;
import sieve.sluice.*;
import sieve.sluice.views.*;
import java.util.*;
import java.awt.*;

//**********************************************************************
// this originally extended TableViewApplet. Changed to extend 
// TableViewJComponent, 1-15-98. All other methods same (lwjones)
//********************************************************************** 
public class ScatterPlot extends TableViewJComponent implements TableView,
    TableViewListener {

    DescriptiveView	horVar 	 = null;
    DescriptiveView	vertVar	 = null;
    String[]		fields	 = null;
    Object[][]		data	 = null;


    public void paint(Graphics g) {
		super.paint(g);
		if (horVar != null) {
	    try {
	        double hScale = size().width/((Number)horVar.getMax()).doubleValue();
	        double vScale = size().height/((Number)vertVar.getMax()).doubleValue();
	        for (int i = 0; i < data[0].length; i++) {
				if((data[0][i] != null) && (data[1][i] != null)) {
					double hVal = ((Number)(data[0][i])).doubleValue() * hScale;
					double vVal = size().height - ((Number)(data[1][i])).doubleValue() * vScale;
					g.drawRect((int)hVal, (int)vVal, 2, 2);
				}
	        }
	    }
	    catch (WrongDataKindException e) {
		e.printStackTrace();
	    }
	}
    }

    public void addSourceView(TableView sourceView) throws
        TooManySourcesException {
	if (source != null)
	    throw new TooManySourcesException();
	resetSource(sourceView);
	//sourceView.addTableViewListener(this);
    }

    private void resetSource(TableView sourceView) {
	try {
	    String[] allFields = sourceView.getFieldNames();
	    if ((allFields == null) || (allFields.length < 2)) {
		horVar = null;
		return;
	    }
	    fields = new String[2];
	    fields[0] = allFields[0];
	    fields[1] = allFields[1];
	    source = new FieldNameSelectionView(new NumberView(sourceView),fields);
	    horVar = new DescriptiveView(source, fields[0]);
	    vertVar = new DescriptiveView(source, fields[1]);
	    data = source.get(fields, 0);
	}
	catch(InterchangeException e) {
	    e.printStackTrace();
	    horVar = null;
	}
    }

    public void removeSourceView(TableView sourceView) {
	if (sourceView == source) {
	    source = null;
	    horVar = null;
	    repaint();
	}
	//sourceView.removeTableViewListener(this);
    }

    public void tableViewChanged(TableViewEvent event) {
	resetSource((TableView)event.getSource());
	repaint();
    }
}
