package sieve.nuggets;

import java.awt.*;
import java.awt.event.*;
import sieve.sluice.*;
import sieve.sluice.event.*;
import sieve.sluice.views.*;

//**********************************************************************
// this originally extended TableViewApplet. Changed to extend 
// TableViewJComponent, 1-15-98. All other methods same (lwjones)
//********************************************************************** 

public class TextTable extends TableViewJComponent implements TableView,
    TableViewListener {
    TextArea ta = null;
    String[] flds = null;

    public TextTable() {
	super();
	setLayout(new BorderLayout());
	ta = new TextArea();
	ta.setEditable(false);
	ta.setText("(Not Connected)");
	ta.setFont(new Font("Monospaced", Font.PLAIN, 10));
	add("Center", ta);
    }

    public void addSourceView(TableView source) throws TooManySourcesException {
	if (this.source != null)
            throw new TooManySourcesException();
        this.source = source;
	reset();
    }

    protected void reset() {
	if (source == null)
	    return;
        try {
	    String[] numAndStringTypes = {
		"java.lang.String",
		"java.lang.Number",
		"java.lang.Long",
		"java.lang.Integer",
		"java.lang.Double",
		"java.lang.Float"};

	    TypeView tv = 
		new TypeView(new LabelView(source), numAndStringTypes);
	    flds = tv.getFieldNames();

	    if (tv.getRecordCount() < 1)
		return;
	    Object[][] data = tv.get(flds, 0);
	    ta.setText("");

	    StringBuffer buf = new StringBuffer();
	    for (int f = 0; f < flds.length; f++) 
		buf.append(getString(flds[f], 10) + " ");
	    buf.append("\n");

	    for (int f = 0; f < flds.length; f++) 
		buf.append("---------- ");
	    buf.append("\n");
	    ta.append(buf.toString());

	    appendRecords(data);
	}
	// If the field wasn't found that probably means that our
	// source has changed in some drastic way. We'll just clear
	// the display and wait for another event.
	catch (sieve.sluice.NoSuchFieldException nsfe) {
	    ta.setText("");
    	}
	catch (sieve.sluice.NoSourceException nse) {
	    ta.setText("");
    	}
	catch (InterchangeException e) {
	    ta.setText("");
	    e.printStackTrace();
	}
    }

    private void appendRecords(Object[][] data) {
	if ((flds == null) || 
	    (data.length < 1) ||
	    (data.length < flds.length) )
	  return;

	int records = data[0].length;

	//	System.out.println("data.length="+data.length+" flds.length="+flds.length );
	//		System.out.println(" ----  records= "+records+" data[0][0]="+data[0][0]);

    
	StringBuffer buf = new StringBuffer();
	for (int r = 0; r < records; r++) {
	  for (int f = 0; f < flds.length; f++) {
	    //	     System.out.println("f="+f+" r="+r);
		if (data[f][r] == null)
		    buf.append(getString("<missing>", 10) + " ");
		else
		    buf.append(getString(data[f][r].toString(), 10) + " ");
	  }
	   buf.append("\n");
	}
	ta.append(buf.toString());
    }

    private String getString(String orig, int len) {
	if (orig.length() > len)
	    return orig.substring(0, len);
	else if (orig.length() < len) {
	    StringBuffer buf = new StringBuffer();
	    while (buf.length() < len - orig.length())
		buf.append(" ");
	    buf.append(orig);
	    return buf.toString();
	}
	return orig;
    }

    public void removeSourceView(TableView source) {
        if (this.source == source) {
            this.source = null;
	    ta.setText("(Not Connected)");
            eventHandler.fireTableViewEvent(new TableViewEvent(this));
        }
    }

    public void tableViewChanged(TableViewEvent event) {
        if (event instanceof AppendEvent) {
	    appendRecords(((AppendEvent)event).getAppendedRecords());
	}
        else
             reset();
        eventHandler.fireTableViewEvent(event);
    }


}

