package sieve.nuggets;

import sieve.sluice.*;
import java.beans.*;
import java.awt.*;

public class VarianceCurve extends TableViewJComponent /* implements TableView, TableViewListener */ {

	//protected CodebookTable			table = null;
	protected PropertyChangeSupport	propChSupp = null;
	protected double				varA = 2.5;
	protected double				varB = 0.45;
	protected static final int		MEAN = 100;
	protected static final int		VARIANCE = 30;
	protected int median = MEAN;
	//private   int					baseX,baseY,maxX,maxY,dotSize;			//for painting
	//protected boolean				positiveSkew = true;
	double max;

	/**
	 * source table, initial fields to use, maximum number of records
	 * Calls super(src, selections, max)
	 */
	public VarianceCurve(TableView src, String[] selections, int max) {
		//super(src,selections,max);
		initLocal();
	}

	/**
	 * source table, initial fields to use -- Calls super(src, selections, 0)
	 */
	public VarianceCurve(TableView src, String[] selections) {
		//super(src,selections,0);
		initLocal();
	}

	/**
	 * source table -- Calls super(src, null, 0)
	 */
	public VarianceCurve(TableView src) {
		//super(src,null,0);
		initLocal();
	}

	/**
	 * Calls super(null, null, 0)
	 */
	public VarianceCurve() {
		//super(null,null,0);
		initLocal();
	}

	private void initLocal() {
		propChSupp = new PropertyChangeSupport(this);	
	   /* dotSize = 4;	//needs to be even number	
		baseX = 40;		//axes drawn for graph
		baseY = 225;
		maxX = 240;
		maxY = 25;*/
		max = normalFunction(MEAN);
	}

	private double logNormalFunction(double x) {
		//the equation is: y=f(log x) = (1/b(sqrt2Pi)) exp(-(log x - a)^2 / 2b^2)
		double denom = varB * Math.sqrt(2*Math.PI);		//denominator
		if(denom != 0) {
			double num = Math.log((double)x);		//log x
			num = (num-varA)*(num-varA);	//(log x - a)^2
			num = Math.exp(-(num/(2*varB*varB)));	//numerator
			return (num / denom);
		}
		else
			return Double.MAX_VALUE;	//divide by zero = "infinity"

		/*
		 * from Richard
		 *
				double num = Math.log((double)x);	//log x
		num = (num-varA)*(num*varA);		//(log x -varA)^2
		num = num/(2*(varB*varB));			//(1/(2*varB^2)) * (log x - varA)^2)
		num = ((varB*varB)/2)-num;			//(varB^2)/2 - (1/(2*varB^2)) * (log x - varA)^2)
		num = varA-num;						//(varA - (varB^2)/2 - (1/(2*varB^2)) * (log x - varA)^2)
		num = (1/((double)x))*Math.exp(num);//1/xEXP(varA - (varB^2)/2 - (1/(2*varB^2)) * (log x - varA)^2)
		return num;
		*/
	}

	private double normalFunction(int x) {	//got from Richard
		double leftFactor = 1/(VARIANCE*(Math.sqrt(2*Math.PI)));
		double exponent = (-Math.pow(x-MEAN, 2))/(2*(Math.pow(VARIANCE, 2)));
		return (leftFactor * (Math.pow(Math.E, exponent)));
	} // normalFunction



	public void paintComponent(Graphics g) {
//		g.drawLine(baseX,baseY,baseX,maxY);
//		g.drawLine(baseX,baseY,maxX,baseY);
	System.out.println("paintComponent");
		int width = getWidth();
		int height = getHeight();

		if(median == MEAN) {
		//g.setColor(Color.red);
		for (int i = 0; i < width; i++) {
				g.drawLine(i, (int)(height-(normalFunction(i)*height/(max*1.1))), i+1 ,
				(int) (height-(normalFunction(i+1)*height/(max*1.1))) );
			}
		}
		else {
	g.setColor(Color.black);
		//do this...
			//set varA, varB based on Math.abs(MEAN-median)
			//then...
			if (median > MEAN) { // positiveSkew
				for (int i = 1; i < (width/4); i++) {//*height/(max*2)
					g.drawLine(i*4, (int)(height-(200 * logNormalFunction((double)i/2))), 
					4*(i+1), (int) (height-(200 * logNormalFunction((double)(i+1)/2))) );
				}
			}
			else { //median < mean --> negativeSkew
				for (int i = 1; i < width/4; i++) {
					//needs to start somewhere closer to middle (MEAN) but -MEAN/2 isn't right either
					g.drawLine(width-(i*4), (int)(height-(200 * logNormalFunction((double)i/2))), 
					width-(4*(i+1)), (int) (height-(200 * logNormalFunction((double)(i+1)/2))) );
				}
			}
		}
	}//paintComponent

/*			for (int i=0;i<25;i+=2) 
				//g.fillOval(baseX+(i*8)+dotSize/2, (-dotSize/2)+(baseY-(int)(200 * logNormalFunction(i/2))),dotSize,dotSize);
				g.drawLine( baseX+(i*8), baseY-(int)(200*logNormalFunction(i/2)), baseX+((i+2)*8), baseY-(int)(200*logNormalFunction((i+2)/2)) );
		}
		else {
			for (int i=0;i<25;i+=2) 
				//g.fillOval(maxX-(i*8)+dotSize/2, (-dotSize/2)+(baseY-(int)(200 * logNormalFunction(i/2))),dotSize,dotSize);
				g.drawLine(maxX-(i*8), baseY-(int)(200*logNormalFunction(i/2)), maxX-((i+2)*8), baseY-(int)(200*logNormalFunction((i+2)/2)) );
	}
*/	

	//********* Visible Properties *********************
	public double getA() {
		return varA;
	}
	public void setA(double a) {
		System.out.println("in setA");
		double old = varA;
		varA = a;
		repaint();
		propChSupp.firePropertyChange("varA", (Object)(new Double(old)), (Object)(new Double(varA)));
	}
	public double getB() {
		return varB;
	}
	public void setB(double b) {
		System.out.println("in setA");
		double old = varB;
		varB = b;
		repaint();
		propChSupp.firePropertyChange("varB", (Object)(new Double(old)), (Object)(new Double(varB)));
	}
	public int getMedian() {
		return median;
	}
	public void setMedian(int num) {
		int old = median;
		median = num;
		repaint();
		propChSupp.firePropertyChange("median", (Object)(new Integer(old)), (Object)(new Integer(median)));
	}



}