package sieve.nuggets.kit;

import java.awt.*;
import java.util.*;

public class AbbreviatedHorizontalAxis extends LabeledHorizontalAxis implements 
	Axis {
    private Object expandedLabel;

    public AbbreviatedHorizontalAxis(Component parent, 
	DataDistributor distributor) {
	super(parent, distributor);
    }

    public Object getExpandedLabel() {
	return expandedLabel;
    }
    public void setExpandedLabel(Object expandedLabel) {
	this.expandedLabel = expandedLabel;
    }

    public void paint(Graphics g) {
	Rectangle bounds = getBounds();
	if (bounds != null) {
	    g.setColor(Color.black);
	    g.drawLine(bounds.x, bounds.y, bounds.x + bounds.width, bounds.y);

	    Object[] labelObjects = getLabelObjects();
	    FontMetrics fm = g.getFontMetrics();
	    int height = fm.getHeight();
	    int first = getFirstPixel();

	    DataDistributor dist = getDataDistributor();
	    if ((labelObjects != null) && (bounds.height >= 2 + height)) {
		String label = null;
		int pos = 0;
		int width = 0;
		int maxWidth = 0;
	        for (int i = 0; i < labelObjects.length; i++) {
		    label = getPrintableLabel(labelObjects[i]);
		    pos = dist.getCentralPixel(labelObjects[i]);
		    width = fm.stringWidth(label);
		    maxWidth = dist.getMaxSize(labelObjects[i]);

		    if ((width > maxWidth) && ((expandedLabel == null) ||
			(! labelObjects[i].equals(expandedLabel)))) {
			String abbrv = ".";
			if (label.length() > 4) {
                            int letters = 0;
                            int labelLen = label.length();
                            String lastAbbrev = null;
                            do {
                                lastAbbrev = abbrv;
                                abbrv = label.substring(0, letters) + ".." +
                                    label.substring(labelLen - letters);
                                letters++;
                            }
                            while ((fm.stringWidth(abbrv) < maxWidth - 2) && 
				(letters < 3));
                            letters--;
                            abbrv = lastAbbrev;
                         }
			 label = abbrv;
		         width = fm.stringWidth(label);
		     }
		     g.setColor(getParent().getForeground());
		     g.drawString(label, first + pos - width/2, 
			bounds.y + 2 + height);
		}
		if (expandedLabel != null) {
		    label = getPrintableLabel(expandedLabel);
		    pos = dist.getCentralPixel(expandedLabel);
		    if (pos >= 0) {
		        width = fm.stringWidth(label);
		        maxWidth = dist.getMaxSize(expandedLabel);
		        g.setColor(getParent().getBackground());
		        g.fillRect(first + pos - width/2 - 2, bounds.y + 2 ,
			    width + 4, height);
		        g.setColor(getParent().getForeground());
		        g.drawString(label, first + pos - width/2, 
			    bounds.y + 2 + height);
		    }
		}
	    }
	}
    }

}



