package sieve.nuggets.kit;

import java.awt.*;
import java.util.*;

public class DateHorizontalAxis extends SimpleHorizontalAxis implements 
	Axis {
    private static String[] DAYS = {"S", "M", "T", "W", "T", "F", "S"};

    public DateHorizontalAxis(Component parent, 
	DateDataDistributor distributor) {
	super(parent, distributor);
    }

    public Dimension getPreferredSize() {
	int fontSize = 0;
	Component p = getParent();
  	if (p.getFont() != null) {
	    FontMetrics fm = p.getFontMetrics(p.getFont());
	    fontSize = fm.getHeight();
	}
	else
	    fontSize = 12; 
	return new Dimension(getParent().getSize().width, 5 + fontSize);
    }

    public void paint(Graphics g) {
	super.paint(g);
	Rectangle bounds = getBounds();
	if (bounds != null) {
	    FontMetrics fm = g.getFontMetrics();
	    int height = fm.getHeight();
	    int first = getFirstPixel();
	    DateDataDistributor dist = 
		(DateDataDistributor)getDataDistributor();
	    if (bounds.height >= 2 + height) {
		Date firstDate = dist.getFirstDate();
		Date lastDate = dist.getLastDate();
		long unit = dist.getUnit();
		int days = 
		    (int)((lastDate.getTime() - firstDate.getTime())/unit);
	        for (int i = 0; i <= days; i++) {
		     Date d = new Date(firstDate.getTime() + i * unit);
		     int pos = dist.getCentralPixel(d);
		     if (pos > 0) {
		         String label = DAYS[d.getDay()];
		         int width = fm.stringWidth(label);
		         g.drawString(label,
			    first + pos - width/2, bounds.y + 2 + height);
		     }
		}
	    }
	}
    }

}



