package sieve.nuggets.kit;

import java.awt.*;

public class SimpleVerticalAxis implements Axis {
    private Component parent = null;
    private Rectangle bounds = null;
    private DataDistributor distributor = null;

    public SimpleVerticalAxis(Component parent, DataDistributor distributor) {
	this.parent = parent;
	this.distributor = distributor;
    }

    protected DataDistributor getDataDistributor() {
	return distributor;
    }

    public Rectangle getBounds() {
	return bounds;
    }

    protected Component getParent() {
	return parent;
    }

    public int getFirstPixel() {
	if (bounds == null)
	    return 0;
	else
	    return bounds.y;
    }

    public int getLastPixel() {
	if (bounds == null)
	    return parent.size().height;
	    // return parent.getSize().height;
	else
	    return bounds.y + bounds.height;
    }

    public Dimension getPreferredSize() {
	// return new Dimension(1, parent.getSize().height);
	return new Dimension(1, parent.size().height);
    }

    public void setBounds(Rectangle bounds) {
	this.bounds = bounds;
	distributor.setSize(bounds.height);
    }

    public int getMaxSize(Object dataPoint) {
	return distributor.getMaxSize(dataPoint);
    }

    public int getCentralPixel(Object dataPoint) {
	return getLastPixel() - distributor.getCentralPixel(dataPoint);
    }

    public Object getDataPoint(int pixel) {
	return distributor.getDataPoint(getLastPixel() - pixel);
    }

    public void paint(Graphics g) {
	if (bounds != null) {
	    g.setColor(Color.black);
	    g.drawLine(bounds.x, bounds.y, bounds.x, bounds.y + bounds.height);
	}
    }

}

