package sieve.nuggets.kit;

import java.awt.*;
import java.awt.event.*;
import java.util.*;

public class Test {

    public Test() {
	Frame f = new Frame("Chart Test");
	ChartComponent c = new ChartComponent();
	f.setSize(new Dimension(400, 400));
	f.setResizable(false);
	f.add("Center", c);
	f.setVisible(true);
    }

    public static void main(String[] args) {
	Test t = new Test();
    }

    class ChartComponent extends Component {
	//private SimpleHorizontalAxis haxis = null;
	private LabeledHorizontalAxis haxis = null;
	//private SimpleVerticalAxis vaxis = null;
	private LabeledVerticalAxis vaxis = null;
        private CategoricalDataDistributor hdist = null;
        //private CategoricalDataDistributor vdist = null;
        private LinearDataDistributor vdist = null;
	private String[] categories = {"A", "B", "C", "D", "E"};
	private String[] hlabels = {"A", "C", "E"};
	private Number[] values = {
	    new Integer(5), 
	    new Integer(7),
	    new Double(9.9),
	    new Integer(7),
	    new Integer(1)};
	private Number[] vlabels = {
	    new Integer(0),
	    new Integer(2),
	    new Double(3.14145),
	    new Double(4.5),
	    new Double(5.5),
	    new Integer(10)
	};
        private Vector dataPoints = null;

	private void init() {
	    hdist = new CategoricalDataDistributor(); 
	    hdist.setCategories(categories);

/*
	    vdist = new CategoricalDataDistributor(); 
	    vdist.setCategories(categories);
*/
	    vdist = new LinearDataDistributor(); 
	    vdist.setMin(0);
	    vdist.setMax(10);

	    haxis = new LabeledHorizontalAxis(this, hdist);
	    haxis.setLabelObjects(hlabels);
	    vaxis = new LabeledVerticalAxis(this, vdist);
	    vaxis.setLabelObjects(vlabels);

	    dataPoints = new Vector();
	    ChartPoint prev = null;

	    for (int i = 0; i < categories.length; i++) {
		VerticalBar b = new VerticalBar(categories[i], values[i]);
		b.setVerticalAxis(vaxis);
		b.setHorizontalAxis(haxis);
		b.setFilled(true);
		b.setBarColor(Color.gray);
		b.setBorderColor(Color.blue);
		b.setScale(0.75);
		dataPoints.addElement(b);
	    }

	    for (int i = 0; i < categories.length; i++) {
		ChartPoint ve = new ChartPoint(categories[i], values[i]);
		ve.setPreviousPoint(prev);
		prev = ve;
		ve.setPointColor(Color.red);
		ve.setLineColor(Color.black);
		ve.setMaxRadius(7);
		ve.setCircular(true);
		ve.setVerticalAxis(vaxis);
		ve.setHorizontalAxis(haxis);
		dataPoints.addElement(ve);
	    }
	}
	public void paint(Graphics g) {
	    if (haxis == null)
	 	init();
	    Dimension size = getSize();
	    g.setColor(Color.white);
	    g.fillRect(0, 0, size.width, size.height);

	    Dimension hPref = haxis.getPreferredSize();
	    Dimension vPref = vaxis.getPreferredSize();

	    haxis.setBounds(new Rectangle(10 + vPref.width, 
		size.height - 10 - hPref.height,
		size.width - 15 - vPref.width, hPref.height));
	    haxis.paint(g);

	    vaxis.setBounds(new Rectangle(10 + vPref.width, 5,
		vPref.width, size.height - 15 - hPref.height));
	    vaxis.paint(g);

	    for (Enumeration e = dataPoints.elements(); e.hasMoreElements();)
		((VisualizationElement)e.nextElement()).paint(g);

  	}

    }

}

