package sieve.nuggets.kit;

import java.awt.*;
import java.awt.event.*;
import java.util.*;

/**
 * A VerticalGridLine draws a line across the chart at a given 
 * data point.
 */
public class VerticalGridLine extends GridLine implements 
    VisualizationElement {

    public VerticalGridLine(Object dataPoint) {
	super(dataPoint);
    }

    public void paint(Graphics g) {
	int startY = vAxis.getFirstPixel();
	int endY = vAxis.getLastPixel();
	int x = hAxis.getCentralPixel(getDataPoint());
	if (x >= 0) {
	    g.setColor(getLineColor());
	    g.drawLine(x, startY, x, endY);
	}
    }

    public boolean contains(int x, int y) {
	return false;
    }

}


