package sieve.phys.blockandplane;
import java.awt.*;
import java.lang.Float;

public class ConstantDialog extends Dialog {

Button Cancel = new Button("Cancel");
Button Ok	    = new Button("Ok");
MovingBody MB = null;
Label GravityLabel      = null;
TextField GravityField  = null;
BlockAndPlane bnp = null;

public ConstantDialog(MovingBody MovBod,Frame parentFrame, BlockAndPlane bnp) {
   super(parentFrame, "Change Constants", false);
   this.bnp = bnp;
   Panel p1 = new Panel();
   MB = MovBod;
   p1.setLayout(new GridLayout(0,2));
   // Gravity
   GravityLabel = new Label("Gravity: (m/s^2) ",Label.LEFT);
   Float f = new Float(MB.getGravity());
   GravityField = new TextField(f.toString(),10);
   p1.add(GravityLabel);
   p1.add(GravityField);

   p1.add(Ok);
   p1.add(Cancel);

   setLayout(new GridLayout(0,1));
   add(p1);   
   
   //Initialize this dialog to its preferred size.
   pack();
}
public boolean action(Event event, Object arg) {

   if (event.target == Cancel){
   	 hide();
      return true;
    }
   if (event.target == Ok) {
      MB.setGravity((Float.valueOf(GravityField.getText())).floatValue());
      hide();
      MB.reset();
      bnp.refresh();
      return true;
   } 
   return false; 
}
}
