package sieve.phys.blockandplane;
import java.awt.*;
import java.lang.Float;

public class DataCollectDialog extends Dialog {

Button Cancel = new Button("Cancel");
Button Ok	    = new Button("Ok");
Block block   = null;
Label TimeStepLabel      = null;
TextField TimeStepField  = null;
BlockAndPlane bnp = null;

public DataCollectDialog(Frame parentFrame, BlockAndPlane bnp) {
   super(parentFrame, "Change Constants", false);
   this.bnp = bnp;
   Panel p1 = new Panel();
   p1.setLayout(new GridLayout(0,2));
   // Gravity
   TimeStepLabel = new Label("Time Step: (s) ",Label.LEFT);
   Float f = new Float(bnp.getTimeStep());
   TimeStepField = new TextField(f.toString(),10);
   p1.add(TimeStepLabel);
   p1.add(TimeStepField);

   p1.add(Ok);
   p1.add(Cancel);

   setLayout(new GridLayout(0,1));
   add(p1);   
   
   //Initialize this dialog to its preferred size.
   pack();
}
public boolean action(Event event, Object arg) {

   if (event.target == Cancel){
   	 hide();
   	 bnp.refresh();
      return true;
    }
   if (event.target == Ok) {
   	 // Enforce minimum timestep value
      if (((Float.valueOf(TimeStepField.getText())).floatValue()) >= 0.01)
         bnp.setTimeStep((Float.valueOf(TimeStepField.getText())).floatValue());
      else 
         bnp.setTimeStep((float)0.01);
      hide();
      bnp.refresh();
      return true;
   } 
   return false; 
}
}
