package sieve.phys.bnp2;

import java.awt.GridLayout;
import java.awt.Frame;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import com.sun.java.swing.*;
import java.lang.Float;

public class MovingBodyDialog extends JFrame implements ActionListener, java.io.Serializable {

  JButton Cancel = new JButton("Cancel");
  JButton Ok	    = new JButton("Ok");
  Block block   = null;
  JLabel HeightLabel      = null;
  JTextField HeightField  = null;
  JLabel LengthLabel      = null;
  JTextField LengthField  = null;
  BlockAndPlane bnp = null;

public MovingBodyDialog(Block b, Frame parentFrame, BlockAndPlane bnp) {
  //   super(parentFrame, "Parameters", false);
   super("Parameters");
   this.bnp = bnp;
   block = b;   
   JPanel p1 = new JPanel();
   p1.setLayout(new GridLayout(0,2));
   // Height
   HeightLabel = new JLabel("Height: (m) ");
   Float f = new Float(block.getHeight());
   HeightField = new JTextField(f.toString(),10);
   p1.add(HeightLabel);
   p1.add(HeightField);
   // Length
   LengthLabel = new JLabel("Length: (m) ");
   f = new Float(block.getLength());
   LengthField = new JTextField(f.toString(),10);
   p1.add(LengthLabel);
   p1.add(LengthField);

   p1.add(Ok);
   p1.add(Cancel);

   Ok.addActionListener(this);
   Cancel.addActionListener(this);

   getContentPane().setLayout(new GridLayout(0,1));
   getContentPane().add(p1);   
      
   //Initialize this dialog to its preferred size.
   pack();
}
  public void actionPerformed(ActionEvent e) {
    Object target = e.getSource();

   if (target == Cancel){
      bnp.refresh();
   	 hide();
      return ;
    }
   if (target == Ok) {
      block.setLength((Float.valueOf(LengthField.getText())).floatValue());
      block.setHeight((Float.valueOf(HeightField.getText())).floatValue());
      hide();
      block.reset();
      bnp.refresh();
      return ;
   } 
   return ; 
}
}
