/*
 *
 * Written By:   James "Bo" Begole
 * Date:         April 23, 1997
 * Description:  Consumer for a channel that recieves block and plane parameter 
 *                   event messages.
 *                   These messages will be converted to calls to a
 *                   BlockAndPlane object.
 *
 * $Header: /home/nie/cvsroot/prototype/vt/cs/virtSchool/client/RoomView.java,v
1.1 1996/12/13 21:43:54 begolej Exp $
 *
 * Copyright (c) 1996 James Bo Begole
 * Copyright (c) 1996 Virginia Polytechnic University and State University
 */
 
package sieve.phys.bnp2; 

import sieve.crew.*;
import SharedData.*;
import SharedData.primitive.*;

/**
 * Consumer for a channel that recieves control 
 * event messages.
 * These messages will be converted to calls to a
 *  object.
 *
 * @version $Revision  $
 */

public class ParameterControl 
extends RemoteControl 
implements SharedFloatObserver {

  public static final String ChannelName = "ParameterControl";

  private BlockAndPlane bnp = null;

  public ParameterControl(Session session, BlockAndPlane bnp) {
    super(session, ChannelName);
    this.bnp = bnp;
    debug("Construction Complete"); 
  }


  /* ------- ChannelConsumer Interface methods ------ */
  public void dataReceived(Data data) {
    debug("dataReceived( "+data+" )");

  }

  /* ------- ChannelConsumer Interface methods ------ */
  public void floatChanged(SharedFloatEvent event) {
    debug("floatChanged");
    bnp.refresh();
  }

  private static  final boolean debug = false;
  private void debug(String msg) {
    if (debug)
      System.out.println(getClass().getName()+": "+msg);
  } 
}
