package sieve.phys.bnp2;

import java.awt.GridLayout;
import java.awt.Frame;
import java.awt.event.KeyListener;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.ActionEvent;
import com.sun.java.swing.*;
import java.lang.Float;

public class PlaneDialog extends JFrame implements ActionListener, KeyListener, java.io.Serializable  {

  JButton Cancel = new JButton("Cancel");
  JButton Ok	    = new JButton("Ok");
  Plane  plane  = null;
  JLabel HeightLabel      = null;
  JTextField HeightField  = null;
  JLabel LengthLabel      = null;
  JTextField LengthField  = null;
  JLabel AngleLabel       = null;
  JTextField AngleField   = null;
  JLabel MuSLabel         = null;
  JTextField MuSField     = null;
  JLabel MuKLabel         = null;
  JTextField MuKField     = null;

  BlockAndPlane bnp = null;

public PlaneDialog(Plane p, Frame parentFrame, BlockAndPlane bnp) {
  //   super(parentFrame, "Change Plane Parameters", false);
   super("Change Plane Parameters");
   this.bnp = bnp;
   plane = p;   
   JPanel p1 = new JPanel();
   p1.setLayout(new GridLayout(0,2));
   // Height
   HeightLabel = new JLabel("Height: (m) ");
   Float f = new Float(plane.getHeight());
   HeightField = new JTextField(f.toString(),10);
   p1.add(HeightLabel);
   p1.add(HeightField);
   // Length
   LengthLabel = new JLabel("Length: (m) ");
   f = new Float(plane.getLength());
   LengthField = new JTextField(f.toString(),10);
   p1.add(LengthLabel);
   p1.add(LengthField);
   // Angle
   AngleLabel = new JLabel("Angle: (deg) ");
   // CONVERT TO DEGREES FOR DISPLAY   
   f = new Float(plane.getAngle() * 180 / java.lang.Math.PI);
   AngleField = new JTextField(f.toString(),10);
   p1.add(AngleLabel);
   p1.add(AngleField);
   // MuS
   MuSLabel = new JLabel("MuS: ");
   f = new Float(plane.getMuS());
   MuSField = new JTextField(f.toString(),10);
   p1.add(MuSLabel);
   p1.add(MuSField);
   // MuK
   MuKLabel = new JLabel("MuK: ");
   f = new Float(plane.getMuK());
   MuKField = new JTextField(f.toString(),10);
   p1.add(MuKLabel);
   p1.add(MuKField);

   p1.add(Ok);
   p1.add(Cancel);

   Ok.addActionListener(this);
   Cancel.addActionListener(this);

   getContentPane().setLayout(new GridLayout(0,1));
   getContentPane().add(p1);   
   
   //Initialize this dialog to its preferred size.
   pack();
}

  public void keyTyped(KeyEvent e) {}
  public void keyPressed(KeyEvent e) {}
  public void keyReleased(KeyEvent e) {
    int key = e.getKeyCode();
    Object target = e.getSource();

  Float f1 = null,f2 = null;
  Double d = null;
  if ((target == HeightField) || (target == LengthField)) {
      f1 = new Float(HeightField.getText());
      f2 = new Float(LengthField.getText());
      d =  new Double((180 / java.lang.Math.PI)*Math.atan((double)f1.floatValue()/(double)f2.floatValue()));
      AngleField.setText(d.toString());
   }
   if (target == AngleField) {
      f1 = new Float(LengthField.getText());
      f2 = new Float(AngleField.getText());
      // CONVERT TO DEGREES FOR DISPLAY
      f2 = new Float((java.lang.Math.PI/180)*f2.floatValue());
      d = new Double((double)f1.floatValue()*Math.tan((double)f2.floatValue()));
      HeightField.setText(d.toString());
   }
   return;
  }

  public void actionPerformed(ActionEvent e) {
    Object target = e.getSource();
    if (target == Cancel){
      hide();
      bnp.refresh();
      return;
    }
    if (target == Ok) {
      debug("Height = "+HeightField.getText()+
	    " Length = "+LengthField.getText() +
	    " Angle = "+AngleField.getText() +
	    " MuS = " + MuSField.getText() +
	    " MuK = " + MuKField.getText());
      
      plane.setLength((Float.valueOf(LengthField.getText())).floatValue());
      // CONVERT FROM DEGREES FOR STORAGE
      plane.setHeight((Float.valueOf(HeightField.getText())).floatValue());
      plane.setAngle((float)(java.lang.Math.PI/180)*
		     (Float.valueOf(AngleField.getText())).floatValue());
      plane.setMuS((Float.valueOf(MuSField.getText())).floatValue());
      plane.setMuK((Float.valueOf(MuKField.getText())).floatValue());
      debug("pre Hide");
      hide();
      debug("post Hide");
      bnp.refresh();
      return;
    } 
    return; 
  }

  private static  final boolean debug = false;
  private void debug(String msg) {
    if (debug)
      System.out.println(getClass().getName()+": "+msg);
  }
}
