package sieve.phys.circuit;

import java.util.*;

public class Edge{
	public int weight;    // weight of the edge
	public int On;        // is this Edge included in matrix
        public int positionx; // row number in matrix
        public int positiony; // column number in matrix
        public int EID;       // edge identification number
        public int CurrentName; //Current Variable Name on this edge
        public int Direction;  //contains the number of the node the current is going
        public Vector Components; //contains all of the components on this edge

Edge(int NewWeight){
	weight = NewWeight;
	On = 0;
        CurrentName = 0;
        Components = new Vector();
        EID = -1;
}

Edge(){
	weight = 0;
	On = 0;
        CurrentName = 0;
        Components = new Vector();
        EID = -1;
}

public void MakeConnection(){
	On = 1;
}

public void RemoveConnection(){
        On = 0;
}

public int GetEID(){
        return EID; 
}

public void AddComponent(CircuitComponent newComp){
//        System.out.println("Add Component Value " + newComp.ComponentID);
        Components.addElement(newComp);
}

public CircuitComponent GetComponent(){
        CircuitComponent temp = null;
        if (!Components.isEmpty()){
           temp = (CircuitComponent)Components.firstElement();
           Components.removeAllElements();
        }
        return temp;
}


public void paintRed(){
        boolean select = true;

        CircuitComponent redComponent;
        redComponent = this.GetComponent();
        redComponent.paintRed(select);
        this.AddComponent(redComponent);
}
  
public void paintBlack(){
        boolean select = false;
 
        CircuitComponent redComponent;
        redComponent = this.GetComponent();
        redComponent.paintRed(select);
        this.AddComponent(redComponent);
}


}
