package sieve.phys.circuit;
import java.awt.*;
import java.lang.Math;
 
public class LightBulb extends CircuitComponent {
        private int Ohms; 
        private double Amps;
 
LightBulb(int SetID){
        ComponentID = SetID;
        Ohms = 10;
}
 
LightBulb(){
        ComponentID = -1;
        Ohms = 10;
}
public int GetValue(){
	return Ohms;
}
public void setAmps(double Amp){
    	Amps = Amp; // this will round up for us.
        this.repaint();
}
 public Dimension getPreferredSize() {
        return new Dimension(70, 150);
    }
public void layout() {
        Dimension pref = t1.getPreferredSize();
        t1.setBounds(2, (150 - pref.height)/2, pref.width, pref.height);
        pref = t2.getPreferredSize();
        t2.setBounds(68 - pref.width, (150 - pref.height)/2, pref.width,
            pref.height);
    }

public void paint(Graphics g) {
        Rectangle t1Bounds = t1.getBounds();
        Rectangle t2Bounds = t2.getBounds();
        if (selected || red)
            g.setColor(Color.red);
        else
            g.setColor(Color.black);
        int y;
        int h;
        int x;
        int w;
 
         y = t1Bounds.y + t1Bounds.height/2;
         h=15;
         x=t1Bounds.x+t1Bounds.width;
         w=t2Bounds.x-x;
 
        int pt1, pt2, pt3, pt4, pt5, pt6, pt7, pt8, pt9;
        int Rpt1, Rpt2, Rpt3, Rpt4, Rpt5, Rpt6, Rpt7, Rpt8, Rpt9;
        int Rx,Ry,Rw,Rh;
        pt1=x+w*2/8;
          pt4 =y+h*2/3;
          pt2 =x+w*6/8;
    
        if (selected )
            g.setColor(Color.red);
        else
            g.setColor(Color.black);
 
         g.drawLine(x, y, pt1, y);
         g.drawLine(pt2,y,x+w,y);
         g.drawArc(x,y-4*h,w,h*3,-60,300);
        // wire.draw (g,pt1,y-3*h,w/2,h/2);
       //  g.drawLine(pt1,y+10*h,pt1,y-10*h);
      //   g.drawLine(pt1,y-3*h - (int)(Math.cos(60)*(float)w/2.),pt1, y);
      //   g.drawLine(pt2,y-3*h - (int)(Math.cos(60)*(float)w/2.) ,pt2, y);
         g.drawLine(pt1,y-h*7/5,pt1, y);
         g.drawLine(pt2,y-h*7/5,pt2, y);


 // here we begin drawing the resistor for inside the light bulb
          if (Amps!=0.0)
                g.setColor(Color.yellow);
 
         Ry = y-h*5/2;
         Rh=h*5/8;
         Rx=pt1;
         Rw=w/2;
          Rpt1=Rx+Rw/3;
          Rpt5 =Rx+Rw/2;
          Rpt2 =Rpt1+(Rpt5-Rpt1)/4;
          Rpt4 =Rpt1+(Rpt5-Rpt1)*3/4;
          Rpt9 =Rx+Rw*2/3;
          Rpt6 =Rpt5+(Rpt9-Rpt5)/4;
          Rpt8 =Rpt5+(Rpt9-Rpt5)*3/4;
         g.drawLine(Rx, Ry, Rpt1, Ry);
         g.drawLine(Rpt1, Ry , Rpt2, Ry+Rh/2);
         g.drawLine(Rpt2, Ry + Rh/2, Rpt4, Ry-Rh/2);
         g.drawLine(Rpt4, Ry - Rh/2, Rpt6, Ry+Rh/2);
         g.drawLine(Rpt6, Ry + Rh/2, Rpt8, Ry-Rh/2);
         g.drawLine(Rpt8, Ry - Rh/2, Rpt9, Ry);
         g.drawLine(Rpt9, Ry, Rx+Rw, Ry);
 
        // Temporarily adding these back in. Feel free to remove them...
        g.fillRect(t1Bounds.x, t1Bounds.y, t1Bounds.width, t1Bounds.height);
        g.fillRect(t2Bounds.x, t2Bounds.y, t2Bounds.width, t2Bounds.height);
   
}
 
 
}

