
package sieve.phys.circuit;
import java.awt.*;
 
public class Resistor extends CircuitComponent{
	private int Ohms;
        private double Amps; 

Resistor(int initOhms, int SetID){
        ComponentID = SetID;
        Ohms = initOhms;
}
 
Resistor(){
        ComponentID = -1;
        Ohms = 10;
}

public void setAmps(int Amp){
        Amps = Amp;
}

public int GetValue(){
        return Ohms;
}
 
public void paint(Graphics g) {
        Rectangle t1Bounds = t1.getBounds();
        Rectangle t2Bounds = t2.getBounds();
        if (selected || red)
            g.setColor(Color.red);
        else
            g.setColor(Color.black);
	int y;
	int h;
	int x;
	int w;


	int pt1, pt2, pt3, pt4, pt5, pt6, pt7, pt8, pt9;
 if (Orientation)  // this is a horizontal compoment
	{
         y = t1Bounds.y + t1Bounds.height/2;
	 h=20;  
	 x=t1Bounds.x;
	 w=t2Bounds.x-t1Bounds.x;
          pt1=x+w/3;
          pt5 =x+w/2;
          pt2 =pt1+(pt5-pt1)/4;
          pt4 =pt1+(pt5-pt1)*3/4;
          pt9 =x+w*2/3;
          pt6 =pt5+(pt9-pt5)/4;
          pt8 =pt5+(pt9-pt5)*3/4;
         g.drawLine(x, y, pt1, y);
         g.drawLine(pt1, y , pt2, y+h/2);
         g.drawLine(pt2, y + h/2, pt4, y-h/2);
         g.drawLine(pt4, y - h/2, pt6, y+h/2);
         g.drawLine(pt6, y + h/2, pt8, y-h/2);
         g.drawLine(pt8, y - h/2, pt9, y);
         g.drawLine(pt9, y, x+w, y);

	// Temporarily adding these back in. Feel free to remove them...
	g.fillRect(t1Bounds.x, t1Bounds.y, t1Bounds.width, t1Bounds.height);
	g.fillRect(t2Bounds.x, t2Bounds.y, t2Bounds.width, t2Bounds.height);
       }
 else if (!Orientation) // this is a verticle component
	{
	  x=t1Bounds.x+t1Bounds.width/2;
          w=20;
	  y=t1Bounds.y;
	  h=t2Bounds.y-t1Bounds.y; 
	  pt1=y+h/3;
          pt5 =y+h/2;
          pt2 =pt1+(pt5-pt1)/4;
          pt4 =pt1+(pt5-pt1)*3/4;
          pt9 =y+h*2/3;
          pt6 =pt5+(pt9-pt5)/4;
          pt8 =pt5+(pt9-pt5)*3/4;
         g.drawLine(x, y, x, pt1);
         g.drawLine( x ,pt1,x+w/2, pt2);
         g.drawLine( x + w/2,pt2, x-w/2,pt4);
         g.drawLine(x - w/2,pt4,  x+w/2,pt6);
         g.drawLine(x + w/2,pt6, x-w/2, pt8);
         g.drawLine(x- w/2,pt8, x, pt9);
         g.drawLine(x,pt9,x,y+h);
	g.fillRect(t1Bounds.x, t1Bounds.y, t1Bounds.width, t1Bounds.height);
	g.fillRect(t2Bounds.x, t2Bounds.y, t2Bounds.width, t2Bounds.height);
 
 
	} 
    }

    public void setResistance(int resistance) {
	this.Ohms = resistance;
    }
    public int getResistance() {
	return Ohms;
    }
    public int getNode1(){
       return node1;
    }
    public void setNode1(int setnull){}

    public int getNode2(){
       return node2;
    }
    public void setNode2(int setnull){}

    public int getDirection(){
       return direction;
    }
    public void setDirection(int dirNull){}
}

