package sieve.phys.circuit;

import java.awt.*;
import java.util.*;
import java.awt.event.*;
import sieve.workbench.*;
public class Terminal extends Component {
    public static final int RADIUS = 5;

    private CircuitComponent cc = null;
    private Integer id = null;
    private Vector links = null;

    public Terminal(CircuitComponent cc) {
	this.cc = cc;
	this.links = new Vector();
	this.id = NodeNumbers.getValue();
	addMouseListener(new Listener(this));
	setCursor(Cursor.getPredefinedCursor(Cursor.CROSSHAIR_CURSOR));
    }

    public CircuitComponent getCircuitComponent() {
	return cc;
    }

    public void setCircuitComponent(CircuitComponent cc) {
	this.cc = cc;
    }

    public Integer getID() {
	return id;
    }

    public void returnID() {
	if (id != null) {
	    NodeNumbers.returnValue(id);
	    id = null;
	}
    }

    public void finalize() {
	returnID();
    }
    public void paint(Graphics g) {
	g.setColor(Color.black);
	g.fillRect(0, 0, 2 * RADIUS - 1, 2 * RADIUS - 1);
    }

    public Dimension getMinimumSize() {
	return new Dimension(2 * RADIUS, 2 * RADIUS);
    }

    public Dimension getPreferredSize() {
	return new Dimension(2 * RADIUS, 2 * RADIUS);
    }

    private class Listener extends MouseAdapter {
	private Terminal t = null;
	public Listener(Terminal t) {
	    this.t = t;
        }
 	public void mouseClicked(MouseEvent e) {
	    t.getCircuitComponent().terminalSelected(t);
	}
    }

    void addLink(CircuitComponentLink link) {
	links.addElement(link);
    }
    void removeLink(CircuitComponentLink link) {
	links.removeElement(link);
    }
    public int numLinks() {
        return links.size();
   }
   void destroyLinks(Workbench wb) {
        for (int i=0; i<links.size(); i++)
        {  
           ((CircuitComponentLink)(links.elementAt(i))).removelinks(this);
           wb.remove((CircuitComponentLink)(links.elementAt(i)));
           wb.linkRemoved((CircuitComponentLink)(links.elementAt(i)));
          
        }
   }

}

