package sieve.phys.demo;

import java.awt.*;
import java.awt.event.*;
import vt.cs.widgets.*;
import sieve.quarry.*;
import sieve.nuggets.*;
import sieve.sluice.*;
import java.beans.*;

public class Demo extends BeanBoxFrame {
    Panel  bottomPanel = null;
    Component radarView = null;

    public Demo(String[] argv) {
	super(argv);
	show();
	remove(statusLabel);
	bottomPanel = new BottomPanel(this);
	bottomPanel.setLayout(new GridLayout(1, 2, 2, 1));
	radarView = scroller.detachRadarView();
	Panel radarPanel = new Panel();
	radarPanel.setLayout(new BorderLayout());
	radarPanel.add("North", new Label("Workspace Overview", Label.CENTER));
	radarPanel.add(radarView);

	ToolBox demoPanel = getToolBox();

	bottomPanel.add(demoPanel); 

	setTitle("Virtual Physics Lab");

	bottomPanel.add(radarPanel);
	add("South", bottomPanel);

	if (atts.get("host") == null) {
	    addModules();
	    addDemoMenu();
	    //getPropertySheet().setVisible(false);
	}
	validate();
    }

    public void addModules() { // TMP -- Just put a simple B&P setup in....
	BeanBox box = getTopBox();

	Rectangle bounds = new Rectangle(50, 50, 100, 100);
 	//Component bnp = new sieve.phys.blockandplane.BlockAndPlane();
 	Component bnp = new sieve.phys.lwblockandplane.BlockAndPlane();
	box.doRemoteInsert(bnp, bounds);
	Wrapper bnpWrapper = Wrapper.findWrapper(bnp);

	bounds = new Rectangle(164, 374, 282, 116);
	Object tsv = new sieve.sluice.views.TableSelectionView();
	box.doRemoteInsert(tsv, bounds);
	Wrapper tsvWrapper = (Wrapper)box.getComponent(0);
	box.doLinkRemote(bnpWrapper, tsvWrapper);

	bounds = new Rectangle(10, 515, 575, 360);
	Component lg = new sieve.nuggets.LineGraph.LineGraph();
	box.doRemoteInsert(lg, bounds);
	lg.setBounds(bounds);
	Wrapper lgWrapper = Wrapper.findWrapper(lg);
	box.doLinkRemote(tsvWrapper, lgWrapper);
	
/*
	bounds = new Rectangle(10, 516, 212, 32);
	sieve.whiteboard.Label note = new sieve.whiteboard.Label();
	note.setText("Double-click to choose a dataset");
	box.doRemoteInsert(note, bounds);
	Wrapper noteWrapper = Wrapper.findWrapper(note);
	noteWrapper.setBounds(bounds);
	box.doLinkRemote(noteWrapper, tsvWrapper);

	bounds = new Rectangle(29, 560, 161, 32);
	note = new sieve.whiteboard.Label();
	note.setText("Just graphing velocity...");
	box.doRemoteInsert(note, bounds);
	noteWrapper = Wrapper.findWrapper(note);
	noteWrapper.setBounds(bounds);
	box.doLinkRemote(noteWrapper, lgWrapper);

	bounds = new Rectangle(44, 484, 114, 32);
	note = new sieve.whiteboard.Label();
	note.setText("First click \"Run\"");
	box.doRemoteInsert(note, bounds);
	noteWrapper = Wrapper.findWrapper(note);
	noteWrapper.setBounds(bounds);
	box.doLinkRemote(noteWrapper, bnpWrapper);
*/

/*
	bounds = new Rectangle(597, 340, 210, 232);
	sieve.whiteboard.PostItNote postIt = new sieve.whiteboard.PostItNote();
	box.doRemoteInsert(postIt, bounds);
*/
    }

    void addDemoMenu() {
	Menu demoMenu = new Menu("Demo");
	CheckboxMenuItem props = new CheckboxMenuItem("Show Property Sheet", 
	    false);
	props.addItemListener(new DemoMenuListener(getPropertySheet()));
	demoMenu.add(props);
	getMenuBar().add(demoMenu);
    }

    public static void main(String argv[]) {
        System.setSecurityManager(new QuarrySecurityManager());
	if ((argv == null) || (argv.length == 0)) {
	    argv = new String[1];
	    argv[0] = "s"; // Default to standalone
	}
	Demo fr = new Demo(argv);
	fr.show();
/*
	Frame buttonFrame = new Frame("Workspaces");
	buttonFrame.setLayout(new BorderLayout());
	buttonFrame.add(new ButtonPanel("simon"));
	buttonFrame.pack();
	buttonFrame.setSize(new Dimension(375, 60));
	buttonFrame.show();
*/
    }

}

class ButtonPanel extends Panel implements ActionListener {
    Demo bnp = null;
    Demo privateSpace = null;
    Demo shared = null;

    public ButtonPanel(String host) {
	setLayout(new GridLayout(1, 3));
	Button b = new Button("Block & Plane");
	b.addActionListener(this);
	add(b);
	b = new Button("Private Workspace");
	b.addActionListener(this);
	add(b);
	b = new Button("Group Workspace");
	b.addActionListener(this);
	add(b);
    }

    public void actionPerformed(ActionEvent e) {
	System.out.println("ActionEvent: " + e);
    }

}

class BottomPanel extends Panel {

    Dimension size 	= null;
    Frame     parent 	= null;

    public BottomPanel(Frame fr) {
	this.parent = fr;
    }

    public Dimension mySize() {
	int w = getParent().getSize().width;
	return new Dimension(w, 125);
    }

    public Dimension getPreferredSize() {
	return mySize();
    }
    public Dimension getMinimumSize() {
	return mySize();
    }
    public Dimension preferredSize() {
	return mySize();
    }
    public Dimension minimumSize() {
	return mySize();
    }

}

class DemoMenuListener implements ItemListener {
    Component c = null;

    public DemoMenuListener(Component c) {
	this.c = c;
    }

    public void itemStateChanged(ItemEvent evt) {
	CheckboxMenuItem mi = (CheckboxMenuItem)evt.getSource();
	boolean state = c.isVisible();
	c.setVisible(!state);
	mi.setState(!state);
    }

}

