package sieve.phys.demo;

import java.awt.*;
import java.awt.event.*;
import java.beans.*;
import java.util.*;
import java.lang.reflect.*;
import sieve.quarry.*;

public class DemoToolMenu extends PopupMenu implements ActionListener, Runnable {
    Vector beanLabels = new Vector();
    Vector beanNames = new Vector();
    Vector beanIcons = new Vector();
    Vector beanJars = new Vector();
    Hashtable labelMap = new Hashtable();
    Object pendingBean = null;

    public DemoToolMenu() {
	super("Add a component");
addNote("Simple WhiteBoard Components");
addBeanClass("sieve.whiteboard.Box");
addBeanClass("sieve.whiteboard.Oval");
//addBeanClass("sieve.whiteboard.Label");
addBeanClass("sieve.whiteboard.PostItNote");
addSeparator();
addNote("Block-and-Plane Components");
addBeanClass("sieve.phys.blockandplane.BlockAndPlane");
addBeanClass("sieve.sluice.views.TableSelectionView");
addBeanClass("sieve.nuggets.LineGraph.LineGraph");
addSeparator();
addNote("Experimental Components");
addBeanClass("sieve.nuggets.TextTable");
addBeanClass("sieve.nuggets.AttributeViewer");
addBeanClass("sieve.phys.lwblockandplane.BlockAndPlane");
//addBeanClass("sieve.nuggets.BarChart");
//addBeanClass("sieve.nuggets.Histogram");
//addBeanClass("sieve.nuggets.Graph");
//addSeparator();
//addBeanClass("sieve.sluice.views.CriteriaView");
//addBeanClass("sieve.sluice.views.FieldNameSelectionView");
//addBeanClass("sieve.sluice.views.FrequencyTableView");
//addBeanClass("sieve.sluice.views.CacheView");
//addBeanClass("sieve.sluice.views.ColorChangeView");
	addActionListener(this);
	Thread life = new Thread(this);
	life.start();
    }

    private void addNote(String note) {
	MenuItem mi = new MenuItem(note);
	add(mi);
	mi.disable();
    }

    synchronized void addBeanClass(String beanClassName) {
        Class beanClass;
        try {
            beanClass = Class.forName(beanClassName);
        } catch (Exception ex) {
            System.err.println("Toolbox: couldn't instantiate " +
                                                             beanClassName);
            return;
        }
        BeanInfo bi;
        try {
            bi = Introspector.getBeanInfo(beanClass);
        } catch (Exception ex) {
            System.err.println("Toolbox: couldn't find BeanInfo for " +
                                                                beanClassName);
            ex.printStackTrace();
            return;
        }

        String label = bi.getBeanDescriptor().getDisplayName();
        label = getUniqueName(beanLabels, label);
	add(label);
	beanLabels.addElement(label);

        Image img = bi.getIcon(BeanInfo.ICON_COLOR_16x16);
	labelMap.put(label, beanClassName);
        beanNames.addElement(beanClassName);
        beanIcons.addElement(img);
        //beanJars.addElement(null);
    }

    // keep it with package scope for the inner class' sake
    String getUniqueName(Vector v, String s) {
        if (! v.contains(s)) {
            return s;
        }
        int count = 2;
        while (v.contains(s+"<"+count+">")) {
            count += 1;
        }
	return s+"<"+count+">";
    }

    public void actionPerformed(ActionEvent evt) {
System.out.println("Got action event: " + evt);
	if (evt.getID() == ActionEvent.ACTION_PERFORMED) {
	    String beanName = (String)labelMap.get(evt.getActionCommand());
System.out.println("Got bean name: " + beanName);
	    if (beanName != null) {
                Object bean = null;
 
                if (beanName.equals("sieve.quarry.BeanBox")) {
                    bean = new BeanBox(new java.util.Hashtable());  // should pass in BeanBoxFrame.atts -Bo
                } 
		else {
/*
                    JarInfo ji = (JarInfo) beanJars.elementAt(row);
                    try {
                        bean = ji.getInstance(beanName);
                    } catch (Exception ex) {
                    // PLI -- This should probably use the Beans instantiation
                    // method?
*/
                    try {
System.out.println("Trying to load: " + beanName);
                        Class cl = Class.forName(beanName);
System.out.println("Got class: " + cl);
                        bean = cl.newInstance();
System.out.println("Got instance: " + bean);
                    } catch (Exception exe) {
			exe.printStackTrace();
                    }
                }
		synchronized(this) {
		    pendingBean = bean;
		    notify();
		}
	    }
	}
    }

    public void run() {
        // We run an internal thread to handle insertions, one at a time.
        for (;;) {
            Object bean;
            synchronized (this) {
                // Wait for a bean to be ready for insertion.
                while (pendingBean == null) {
                    try {
                        wait();
                    } catch (InterruptedException ix) {
                        System.err.println("ToolBox.run: unexpected interrupt");
                    }
                }
                bean = pendingBean;
            }
 
            // Figure our the current BeanBox.
            BeanBox box = BeanBoxFrame.getCurrentBeanBox();
 
            // Change the cursor to indicate an "insert".
            //frame.setCursor(crosshairCursor);
 
            // do the insertion.
            box.doInsert(bean);
 
            // Clear any pending bean.  This will normally be the bean we
            // just inserted, but we also want to clear any bogus insert
            // that has been queued since we started.
            pendingBean = null;
 
            //frame.setCursor(defaultCursor);
        }

    }
    
}

