/*
 *
 * Written By: 	Michael Parks
 * Date:			6/23/96
 * Description:	Plane Class (Extends Surface)
 *
 * Usage Notes:
 *
 * 
 */
/*
 *
 * Copyright (c) 1996 Michael Parks. All Rights Reserved.
 *
 * 
 */
package sieve.phys.lwblockandplane;

import java.awt.*;

public class Plane extends Surface {
boolean LeftHanded;

   public Plane(float ht,
		float lngth,
		float NewMuS,
		float NewMuK,
		float NewMuR,
		int StartPos,
		boolean LeftHand) {
     super(ht, lngth, NewMuS, NewMuK, NewMuR, StartPos);
     LeftHanded = LeftHand;
   }

   public Plane(float ht,
		float lngth,
		float NewMuS,
		float NewMuK,
		float NewMuR,
		int StartPos,
		boolean LeftHand,
		String name) {
      super(ht, lngth, NewMuS, NewMuK, NewMuR, StartPos, name);
      LeftHanded = LeftHand;
   }

   public void paint(Graphics g,Dimension d) {
     init(); // Be sure plane is valid
     int xarr[] = new int[3];
     int yarr[] = new int[3];
   	 
     if (PlanePoly == null) {
       if (LeftHanded == true) {
         // Top Left
         xarr[0] = LeftEnd;
         yarr[0] = (int)(d.height-(getHeight() * SimCanvas.ScaleFactor));
         // Bottom Left
         xarr[1] = LeftEnd;
         yarr[1] = d.height;
         // Bottom Right
         xarr[2] = (int)(getLength() * SimCanvas.ScaleFactor) + LeftEnd;
         yarr[2] = d.height;
         PlanePoly = new Polygon(xarr,yarr,3);
       } else { // Righthanded plane
         // Top Right
         xarr[0] = (int)(LeftEnd + (getLength() * SimCanvas.ScaleFactor));
	 yarr[0] = (int)(d.height-(getHeight() * SimCanvas.ScaleFactor));
	 // Bottom Left
         xarr[1] = LeftEnd;
         yarr[1] = d.height;
         // Bottom Right
         xarr[2] = (int)(getLength() * SimCanvas.ScaleFactor) + LeftEnd;
	 yarr[2] = d.height;
         PlanePoly = new Polygon(xarr,yarr,3);
       }
     }
     g.setColor(Color.red);
     g.fillPolygon(PlanePoly);
   }
}
