package sieve.phys.lwblockandplane;
import java.awt.*;

//class SimCanvas extends Canvas {
class SimCanvas extends Component {
	// Units of pixel / meter
     public static final float ScaleFactor = 100;
     private Plane plane1;
     private Plane plane2;     
  private Plane floor;     
  private MovingBody MB;
  transient Dimension offDimension;
  transient Image     offImage;
  transient Graphics  offGraphics;
  SimCanvas(Plane p1, Plane p2, Plane f, MovingBody MovBod){
    plane1 = p1;
    plane2 = p2;
    floor  = f;
    MB  = MovBod;
    setForeground(Color.red);
  }
  public void paint(Graphics g) {
    //    System.out.println("SimCanvas.paint offGraphics="+offGraphics);

    Dimension d = size();
    if ( (offGraphics == null) || 
	 (offDimension == null) ||
	 (d.width != offDimension.width) || 
	 (d.height != offDimension.height) ) {
      //     System.out.println("SimCanvas.paint getting a new offGraphics="+offGraphics);
     offDimension = d;
      offImage = createImage(d.width, d.height);
      offGraphics = offImage.getGraphics();
      offGraphics.setFont(g.getFont());
      MB.reset();
    }

    //PLI offGraphics.setColor(Color.black);
   offGraphics.setColor(getBackground());

   offGraphics.fillRect(0,0,d.width,d.height);
  		  		
    //PLI offGraphics.setColor(Color.red);
    offGraphics.setColor(getForeground());
    plane1.paint(offGraphics, d);
    plane2.paint(offGraphics, d);		
    MB.paint(offGraphics, d);
    floor.paint(offGraphics, d);
    // Draw in Floor as a line
    offGraphics.drawLine(Math.round(ScaleFactor*plane1.getRightEnd()),d.height-1,Math.round(ScaleFactor*(plane1.getRightEnd()+floor.getLength())),d.height-1);
		
    g.drawImage(offImage, 0, 0, null);		
  }
  public Dimension minimumSize() {
    return new Dimension(500, 250);
  }
  public Dimension preferredSize() {
    return minimumSize();
  }
  public void update(Graphics g) {
    //    System.out.println("SimCanvas.paint");
    paint(g);
  }
} 
