
/**
 * Take a generic component Editor and wrap it in a Dialog box.
 * this includes adding the Frame and the "ok" and "cancel" buttons.
 */

package sieve.quarry;

import java.awt.*;
import java.beans.*;


public class CustomizerDialog extends Dialog {

    public CustomizerDialog(Frame frame, Customizer customizer, Object target) {
	super(frame, customizer.getClass().getName(), true);

        this.customizerComponent = (Component)customizer;

        setLayout(null);

	add(customizerComponent);
	doneButton = new Button("Done");
	add(doneButton);

	Dimension d = customizerComponent.preferredSize();
	int width = d.width;
	int height = vpad + d.height + 35;
	if (width < 150) {
	    width = 150;
	}

	resize(width, height);
	show();
    }

    public void layout() {
	int width = size().width;
	int height = size().height;
	customizerComponent.setBounds(0, vpad, width, height-(vpad+35));
	doneButton.setBounds((width-140)/2, height-30, 140, 25);
    }

    public boolean handleEvent(Event evt) {
	if (evt.id == Event.WINDOW_DESTROY) {
	    dispose();
	    return true;
	} else if (evt.target == doneButton && evt.id == Event.ACTION_EVENT) {
	    dispose();
	    return true;
	}
	
	return false;
    }


    private Component customizerComponent;
    private Button doneButton;
    private static int vpad = 25;
}
