
/**
 * Pop up a (modal) error dialog and wait for a user to press "continue".
 */

package sieve.quarry;

import java.awt.*;
import java.beans.*;

public class ErrorDialog extends Dialog {

    public ErrorDialog(Frame frame, String message) {
	super(frame, "Error", true);
	
	GridBagLayout gridBag = new GridBagLayout();
	setLayout(gridBag);

	// Add a "Label" for reach line of text.
	int width = 400;
	int height = 5;
	while (message.length() > 0) {
	    int ix = message.indexOf('\n');
	    String line;
	    if (ix >= 0) {
		line = message.substring(0, ix);
		message = message.substring(ix+1);
	    } else {
		line = message;
		message = "";
	    }
	    Label l = new Label(line);
	    GridBagConstraints cons = new GridBagConstraints();
	    cons.gridwidth = GridBagConstraints.REMAINDER;
	    gridBag.setConstraints(l, cons);
	    add(l);
	    height += 20;
	}

	Button b = new Button("Continue");
	GridBagConstraints cons = new GridBagConstraints();
	cons.gridwidth = GridBagConstraints.REMAINDER;
	gridBag.setConstraints(b, cons);
	add(b);
	height += 25;
	height += 35;
	

	resize(400, height+5);
	show();
    }

    public boolean handleEvent(Event evt) {
	if (evt.id == Event.WINDOW_DESTROY) {
	    dispose();
	    return (true);
	}
	if (evt.id == Event.ACTION_EVENT) {
	    dispose();
	    return (true);
	}
	return (false);
    }

}
