
package sieve.quarry;

/**
 * OurLabel draws a string to reprensent an invisible bean.
 *
 * It differs from java.awt.Label in that it forwards mice events
 * up to its container, which makes it friendlier in the BeanBox.
 */

import java.awt.*;

public class OurLabel extends Canvas {
    private Object 	bean = null;
    private Font   	f	= null;
    private FontMetrics	fm	= null;
    private int 	height	= 0;
    private int 	width	= 0;

    public OurLabel(String label) {
	this.label = label;
	f = new Font("Helvetica", Font.PLAIN, 10);
	setFont(f);
	fm = getFontMetrics(f);
	baseline = fm.getMaxAscent() + 2;
	height = baseline + fm.getMaxDescent() + 2;
	width = fm.stringWidth(label) + 6;
	resize(width,height);
    }

// PLI
    public OurLabel(String label, Object bean) {
	this(label);
	this.bean = bean;
    }
    public Object getBean() {
	return bean;
    }
// PLI

    public void paint(Graphics g) {
if ((bean != null) && (bean instanceof sieve.sluice.weblog.TableImpl))
label = ((sieve.sluice.weblog.TableImpl)bean).getLocation();
	int width = fm.stringWidth(label) + 6;
	resize(width,height);
	g.drawString(label, 3, baseline);
    }

    String label;
    int baseline;
}
