package sieve.quarry;

import java.beans.*;
import java.awt.*;

/**
 * Overriding getPropertyDescriptors() to hide the cursorMoved property.
 */
public class QuarryBoxBeanInfo extends SimpleBeanInfo {

    public BeanDescriptor getBeanDescriptor() {
	BeanDescriptor bd = new BeanDescriptor(QuarryBox.class);
	bd.setDisplayName("Quarry Workspace");
	return bd;
    }

    public PropertyDescriptor[] getPropertyDescriptors() {
	try {
	  PropertyDescriptor bg = 
	    new PropertyDescriptor("background", QuarryBox.class);
	  PropertyDescriptor fg = 
	    new PropertyDescriptor("foreground", QuarryBox.class);
	  PropertyDescriptor font = 
	    new PropertyDescriptor("font", QuarryBox.class);
	  PropertyDescriptor name = 
	    new PropertyDescriptor("name", QuarryBox.class);
	  PropertyDescriptor cursorMoved = 
	    new PropertyDescriptor("cursorMoved", QuarryBox.class);
	  cursorMoved.setHidden(true);

	  PropertyDescriptor[] descriptors = {bg, fg, font, name, cursorMoved};
	  return descriptors;
	}
	catch (IntrospectionException e) {
	  throw new Error(e.toString());
	}
    }

}

