package sieve.sluice;

import java.util.*;


/**
 * 
 * Need: version, label field, indep var field
 * 
 * Put introspection/versioning capability in here?
 */
public class TableDescriptor {
  private String labelField 		  = null;
  private String independentVariableField = null;
  private Hashtable attributes		  = null;
  private String name			  = null;

  public TableDescriptor() {
	attributes = new Hashtable();
  }

  public void copyFromSource(TableDescriptor td) {
    if (td != null) {
      labelField = td.getLabelField();
      independentVariableField = td.getIndependentVariableField();
      attributes = td.attributes; // Clone this?
    }
    else
      clear();
  }

  public void clear() {
    labelField = null;
    independentVariableField = null;
  }

  public void removeFields(String[] fields) {
    for (int i = 0; i < fields.length; i++) {
      if (fields[i].equals(labelField))
        labelField = null;
      if (fields[i].equals(independentVariableField))
        independentVariableField = null;
    }
  }

  public String getLabelField() { 
    return labelField;
  }
  public void setLabelField(String labelField) { 
    this.labelField = labelField;
  }

  public String getIndependentVariableField() { 
    return independentVariableField;
  }
  public void setIndependentVariableField(String independentVariableField) { 
    this.independentVariableField = independentVariableField;
  }

    /**
     * Return an attribute
     */
    public Object getAttribute(String name) {
      	return attributes.get(name);
    }

    public String[] getAttributeNames() {
	// Do a brain-dead sort on these...
	Vector names = new Vector(attributes.size());
	for (Enumeration e = attributes.keys(); e.hasMoreElements();) {
	    String key = (String)e.nextElement();
	    int i = 0;
	    for (i = 0; i < names.size() && 
		key.compareTo((String)names.elementAt(i)) > 0; i++);
	    names.insertElementAt(key, i);
	}
	String[] tmp = new String[names.size()];
	names.copyInto(tmp);
	return tmp;
    }
  
    /**
     * Set an attribute
     */
    public void setAttribute(String name, Object value) {
	attributes.put(name, value);
    }

    /**
     * Set the name of this table
     */
    public void setName(String name) {
	this.name = name;
    }

    /**
     * Get the name of this table
     */
    public String getName() {
	return name;
    }

}

