package sieve.sluice;

/**
 * The root event class for all sluice events. We follow the AWT convention
 * of putting the root event class here (in sieve.sluice) and putting
 * subclasses representing specific events in package sieve.sluice.event.
 * The default behavior for most view upon recieving a TableViewEvent
 * should be to reset themselves completely. 
 * More sophisticated views should check for relevent subclasses and, 
 * if possible, process the event in a more appropriate way.
 *
 * Note that many of the constants in this class will be going away as
 * new event subclasses are defined.
 */
public class TableViewEvent extends java.util.EventObject {
	/**
	 * This is one possible way that connecting and disconnecting
	 * views could be accomplished. Not sure I like it, though...
	 */
/*
	public final static int SOURCE_CHANGED		= 0;
	public final static int CELLS_CHANGED 		= 1;

	public final static int FIELDS_ADDED		= 2; 
	public final static int RECORDS_ADDED		= 3;

	public final static int FIELDS_REMOVED		= 4; 
	public final static int RECORDS_REMOVED		= 5; 
*/
	/* Not sure how this would be handled... */
/*
	public final static int FIELD_NAMES_CHANGED = 6;
*/

	/**
	 * This is a "catch-all" that indicates that listeners should
	 * re-get all of their data. It should (probably) be used as an alternative
	 * to sending a large number of other types of events representing
	 * what is essentially a single complex change. 
	 */
/*
	public final static int REFRESH_REQUESTED	= 7;

	private int 		eventType				= -1;
	private	String[] 	changedFields			= null;
*/

	public TableViewEvent(TableView source) {
	    super(source);
	}


	/**
	 * Return a list of fields which have been changed.
	 */
/*
	public String[] changedFields() {
	    return null;
	}
*/

	/**
	 * Should we track changed records by ranges or arrays?
	 */
/*
	public int[] changedRecords() {
	    return null;
	}
*/

}

