package sieve.sluice.codebook;

import java.beans.*;
import java.awt.*;
import java.awt.event.*;
import sieve.sluice.*;

public class CachedSGMLTableCustomizer extends Panel implements
    Customizer, PropertyChangeListener {
    CachedSGMLTable table = null;
    Label typeLabel = null;
    Label locationLabel = null;
    PropertyConfirmString location = null;

    public CachedSGMLTableCustomizer() {
        super();
        setLayout(new BorderLayout());
    }

    public void setObject(Object obj) {
        table = (CachedSGMLTable) obj;
        location = new PropertyConfirmString(table, support);
        add(location, "Center");
    }


    //----------------------------------------------------------------------
 
    public void addPropertyChangeListener(PropertyChangeListener l) {
        support.addPropertyChangeListener(l);
    }
 
    public void removePropertyChangeListener(PropertyChangeListener l) {
        support.removePropertyChangeListener(l);
    }
 
    private PropertyChangeSupport support = new PropertyChangeSupport(this);
 
    //----------------------------------------------------------------------

    public void propertyChange(PropertyChangeEvent evt) {
	if (evt.getPropertyName().equals("location")) {
	    location.tf.setText((String)evt.getNewValue());
            location.tf.setForeground(Color.black);
	}
    }
}


class PropertyConfirmString extends Panel implements ActionListener
{
    TextField tf;
    Button confirm = new Button("set");
    CachedSGMLTable table = null;
    PropertyChangeSupport support = null;

    String orig = null;
 
    PropertyConfirmString(CachedSGMLTable t, PropertyChangeSupport support)
    {
        setLayout(new FlowLayout(FlowLayout.CENTER, 0, 0));
 
        tf = new TextField(t.getLocation(), 30);
 
        add(confirm);
        add(tf);
        confirm.addActionListener(this);
 
        this.table = t;
        this.support = support;
    }
 
    public void actionPerformed(ActionEvent e)
    {
        setLocation();
    }
 
    public void repaint()
    {
        tf.setText(table.getLocation());
    }
 
    public boolean keyUp(Event e, int key) {
        if (e.target == tf) {
            if (key == KeyEvent.VK_ENTER) {
                setLocation();
                tf.setForeground(Color.black);
            }
            else if (key == KeyEvent.VK_ESCAPE) {
                if (!orig.equals(tf.getText())) {
                    tf.setText(orig);
                    setLocation();
                }
                tf.setForeground(Color.black);
            }
            try {
                tf.setForeground(Color.red);
            } catch (IllegalArgumentException ex) {
                // Quietly ignore.
            }
        }
        return (false);
    } 

    private void setLocation() {
        support.firePropertyChange("location", table.getLocation(), 
	    tf.getText());
	try {
            table.setLocation(tf.getText());
	}
	catch(InterchangeException e) {
	    e.printStackTrace();
	}
        tf.setForeground(Color.black);
        orig = tf.getText();
    }

}

