package sieve.sluice.views;

import java.beans.*;
import java.awt.*;
import java.util.*;
import java.awt.event.*;
import sieve.sluice.*;

public class FrequencyTableViewCustomizer extends Container implements 
    Customizer, TableViewListener, PropertyChangeListener, ItemListener {
    public static final String NOT_CONNECTED_MSG = "(Not Connected)";
    private static Dimension zero = new Dimension(0,0);

    private FrequencyTableView target;
    private FieldChoice	 fieldChoice;


    public FrequencyTableViewCustomizer() {
	setLayout(new BorderLayout());
    }

    public void setObject(Object obj) {
	target = (FrequencyTableView) obj;

	fieldChoice = new FieldChoice(target.origSource);
	fieldChoice.addItemListener(this);
	target.addTableViewListener(this);
	target.addPropertyChangeListener(this);

	add("Center", fieldChoice);
	fieldChoice.reshape(80, 5, 100, 30);

	update();
    }

    protected void update() {
	fieldChoice.setTableView(target.origSource);
	fieldChoice.reset();

	String selection = fieldChoice.getSelectedItem();
       	if ((target.getField() == null) && (selection != null)) {
            target.setField(selection);
        }
        if ((selection != null) && !(selection.equals(target.getField())))
            fieldChoice.select(target.getField());

	Dimension choiceSize = fieldChoice.getPreferredSize();
	//size = new Dimension(choiceSize.width + 5, choiceSize.height + 2);
	setSize(choiceSize);
    }

    public void itemStateChanged(ItemEvent evt) {
	String txt = fieldChoice.getSelectedItem();
	if (! txt.equals(NOT_CONNECTED_MSG) && 
	    ! txt.equals(target.getField())) {
	    support.firePropertyChange("field", target.getField(), txt);
	    target.setField(txt);
	}
    }

    //----------------------------------------------------------------------

    public void addPropertyChangeListener(PropertyChangeListener l) {
	support.addPropertyChangeListener(l);
    }

    public void removePropertyChangeListener(PropertyChangeListener l) {
	support.removePropertyChangeListener(l);
    }

    private PropertyChangeSupport support = new PropertyChangeSupport(this);

    //----------------------------------------------------------------------

    public void tableViewChanged(TableViewEvent event) {
	update();
    }

    public void propertyChange(PropertyChangeEvent evt) {
	if (evt.getPropertyName().equals("field")) {
	    String selection = (String)evt.getNewValue();
	    try {
	        FieldDescriptor fd = target.getFieldDescriptor(selection);
		if ((fd != null) && (fd.getDescription() != null))
		    selection = fd.getDescription();
	    }
	    catch (InterchangeException e) { }
	    fieldChoice.select(selection);
	}
    }

    public Dimension getPreferredSize() {
	Dimension current = getSize();
	return (current.equals(zero) ? super.getPreferredSize() : current);
    }

}


