package sieve.sluice.views;

import sieve.sluice.*;
import java.util.*;

/**
 * A LabelView encapsulates translation of NOMINAL (and ORDINAL??) raw
 * values into Strings. 
 */
public class LabelView extends TranslationView implements TableView {
    protected Hashtable	fieldsToTranslate	= null;

    public LabelView(TableView source) throws InterchangeException {
	super(source);
	String[] fields = source.getFieldNames();
	for (int i = 0; i < fields.length; i++) {
            FieldDescriptor fd = source.getFieldDescriptor(fields[i]);
	    Hashtable labels = fd.getLabels();
	    if ((labels != null) && ((fd.getLevel() == 
		FieldDescriptor.LEVEL_NOMINAL) ||
		(fd.getLevel() == FieldDescriptor.LEVEL_ORDINAL))) {
		addTranslation(fields[i], labels);
	    }
	}
    }
}


