package sieve.sluice.views;

import sieve.sluice.*;
import java.util.*;

/**
 * A LevelView hides all fields in a table other than those of a set
 * of levels specified at construction. 
 * 
 */
public class LevelView extends SelectionView implements TableView {
    /* Levels that we recognize */
    private int[]	levels = null;

    public LevelView(TableView source, int[] levels) {
	super(source, new LevelSelectionTest(levels));
	this.levels = levels;
    }
}

class LevelSelectionTest implements SelectionTest {
    private Hashtable	allowedLevels = null;

    public LevelSelectionTest(int[] levels) {
	this.allowedLevels = new Hashtable();
	for (int i = 0; i < levels.length; i++) 
	    allowedLevels.put(new Integer(levels[i]), "OK"); 
    }

    public boolean showField(TableView source, String field) {
	try {
	    return (allowedLevels.get(
		new Integer(source.getFieldDescriptor(field).getLevel())) 
		!= null);
	}
	catch (InterchangeException e) {
	    return false;
	}
    }

}


