package sieve.sluice.views;

import sieve.sluice.*;
import java.util.*;

/**
 * A NumberView hides all fields in a table other than those which
 * subclass from java.lang.Number. It also provides access methods
 * for returning arrays of primitive types.
 */
public class NumberView extends TypeView implements TableView {
    /* Types that we recognize */
    private static final String[] numberTypes = {
	"java.lang.Number",
	"java.lang.Double",
	"java.lang.Float",
	"java.lang.Integer",
	"java.lang.Long"
    };

    public NumberView(TableView source) {
	super(source, numberTypes);
    }
}

