package sieve.sluice.views;

import sieve.sluice.*;
import java.util.*;

/**
 * A TypeView hides all fields in a table other than those of a set
 * of types specified at construction. This eventually needs to
 * use isAssignableFrom() to be a bit more general...
 */
public class TypeView extends SelectionView implements TableView {
    /* Types that we recognize */
    private String[]	types	= null;

    public TypeView(TableView source, String[] types) {
	super(source, new TypeSelectionTest(types));
	this.types = types;
    }
}

class TypeSelectionTest implements SelectionTest {
    private Hashtable	allowedTypes	= null;

    public TypeSelectionTest(String[] types) {
	this.allowedTypes = new Hashtable();
	for (int i = 0; i < types.length; i++) 
	    allowedTypes.put(types[i], "OK"); 
    }

    public boolean showField(TableView source, String field) {
	try {
	    return (allowedTypes.get(source.getFieldDescriptor(field).getType()
                ) != null);
	}
	catch (InterchangeException e) {
	    return false;
	}
    }

}


