package sieve.sluice.views.predicates;

import java.lang.reflect.Method;

public class BinaryPredicate extends Predicate {

    public BinaryPredicate (Class aClass, String name) throws
        NoSuchMethodException {
	super(aClass, name); 
    }

    protected BinaryPredicate(Class aClass, Method predicateMethod) {
	super(aClass, predicateMethod);
    }

    public boolean execute(Object firstArg, Object secondArg) {
	Boolean result = new Boolean(false);
	if ((secondArg == null) || (firstArg == null))
	    return false;
	try {
            Object[] args = {firstArg, secondArg};
            result = (Boolean)(predicateMethod.invoke(predicatesObject, args));
        }
        catch(java.lang.reflect.InvocationTargetException e) {
	    System.err.println("Predicates object = " + predicatesObject);
	    System.err.println("Predicate method = " + predicateMethod);
            e.printStackTrace();
            e.getTargetException().printStackTrace();
        }
        catch(Exception ex) {
            ex.printStackTrace();
	}
        return result.booleanValue();
    }

}

