package sieve.sluice.views.predicates;

import sieve.sluice.*;
import java.awt.*;

public class PredicateChoice extends Choice {
    String 	type 	= "java.lang.Object";
    Font 	myFont	= getFont();

    public PredicateChoice() { }

    public PredicateChoice(String type) {
	this.type = type;
    }

    public String getType() {
	return type;
    }

    public void setType(String type) {
	this.type = type;
	reset();
    }

    public void reset() {
	String[] unary = null;
	String[] binary = null;

	try {
	    Class c = Class.forName(type);
	    unary = Predicate.getUnaryPredicateNames(c);
	    binary = Predicate.getBinaryPredicateNames(c);
	}
	catch(Exception e) {}

	if ((binary.length == 0) && (unary.length == 0)) {
	    removeAll();
	    disable();
	    // Enabling/Disabling makes the font get bigger...
	    setFont(myFont);
	}
	else {
	    String selection = getSelectedItem();
	    for (int i = 0; i < unary.length; i++) {
		if ((getItemCount() <= i) || (!getItem(i).equals(unary[i])))
		    insert(unary[i], i);
	    }
	    // insert("-----------------------", unary.length);
	    for (int i = 0; i < binary.length; i++) {
		if ((getItemCount() <= unary.length + i) || 
		   (!getItem(unary.length + i).equals(binary[i])))
		    insert(binary[i], i);
	    }
	    int itemCount = getItemCount();
	    for (int j = unary.length + binary.length; j < itemCount; j++)
		remove(unary.length + binary.length);

	    if (selection != null)
	        select(selection);

	    enable();
	    // Enabling/Disabling makes the font get bigger...
	    setFont(myFont);
	}

    }

}



