package sieve.whiteboard;

import java.awt.*;
import java.awt.event.*;
import sieve.workbench.*;

/**
 * Tool for constructing a Line object.
 */
public class LineTool implements Tool {
    Workbench wb = null;
    Line line = null;

    public LineTool(Workbench wb) {
	this.wb = wb;
    }

    public LineTool() { }

    public void init(Workbench wb, Class cl) {
	this.wb = wb;
    }

    private void handleMouseEvent(MouseEvent e) {
	if (line != null) {
	    line.end = e.getPoint();
	    line.setBounds(line.getBounds());
	    line.repaint();
	}
    }

    public void mousePressed(MouseEvent e) { 
	if (line == null) {
	    line = new Line(e.getPoint(), e.getPoint(), wb);
	    line.addPropertyChangeListener(new PropListener(wb, line));
	    line.addMouseListener(this);
	    line.addMouseMotionListener(this);
	    wb.add(line, -1);
	}
    }
    public void mouseReleased(MouseEvent e) { 
	if (line != null) {
	    handleMouseEvent(e);
	    wb.componentAdded(line, this);
	    line.removeMouseListener(this);
	    line.removeMouseMotionListener(this);
	    line.setConstructed(true);
	    line = null;
	}
    }

    public void mouseClicked(MouseEvent e) { }
    public void mouseEntered(MouseEvent e) { 
	if (line != null)
	    handleMouseEvent(e);
    }
    public void mouseExited(MouseEvent e) { }
    public void mouseMoved(MouseEvent e) { }
    public void mouseDragged(MouseEvent e) { 
	if (line != null) {
	    handleMouseEvent(e);
	}
    }

    public Cursor getPreferredCursor() {
	return null;
    }

}



