package sieve.whiteboard;

import java.awt.*;
import java.awt.event.*;
import sieve.workbench.*;

/**
 * Tool for constructing a Oval object.
 */
public class OvalTool implements Tool {
    Workbench wb = null;
    Oval oval = null;

    public OvalTool(Workbench wb) {
	this.wb = wb;
    }

    public OvalTool() { }

    public void init(Workbench wb, Class cl) {
	this.wb = wb;
    }

    private void handleMouseEvent(MouseEvent e) {
	if (oval != null) {
	    oval.end = e.getPoint();
	    oval.setBounds(oval.getBounds());
	    oval.repaint();
	}
    }

    public void mousePressed(MouseEvent e) { 
	if (oval == null) {
	    oval = new Oval(e.getPoint(), e.getPoint(), wb);
	    oval.addMouseListener(this);
	    oval.addMouseMotionListener(this);
	    wb.add(oval, -1);
	}
    }
    public void mouseReleased(MouseEvent e) { 
	if (oval != null) {
	    handleMouseEvent(e);
	    wb.componentAdded(oval, this);
	    oval.removeMouseListener(this);
	    oval.removeMouseMotionListener(this);
	    oval.addPropertyChangeListener(new PropListener(wb, oval));
	    oval.setConstructed(true);
	    oval = null;
	}
    }

    public void mouseClicked(MouseEvent e) { }
    public void mouseEntered(MouseEvent e) { 
	if (oval != null)
	    handleMouseEvent(e);
    }
    public void mouseExited(MouseEvent e) { }
    public void mouseMoved(MouseEvent e) { }
    public void mouseDragged(MouseEvent e) { 
	if (oval != null) {
	    handleMouseEvent(e);
	}
    }

    public Cursor getPreferredCursor() {
	return null;
    }

}



