package sieve.whiteboard;

import java.beans.*;
import sieve.workbench.Workbench;
import sieve.workbench.WorkbenchComponent;

/**
 * This support class simply listens for property changes from a component
 * and propagates them to the Workbench.
 */
public class PropListener implements PropertyChangeListener {
    private Workbench wb = null;
    private WorkbenchComponent wbc = null;

    public PropListener(Workbench wb, WorkbenchComponent wbc) {
	this.wb = wb;
	this.wbc = wbc;
    }

    public void propertyChange(PropertyChangeEvent e) {
// System.out.println("Got propchange: " + e.getPropertyName() + " old: " + e.getOldValue() + " new: " + e.getNewValue());
	wb.componentEdited(wbc, e);
    }

}

