package sieve.whiteboard;

import java.beans.*;

public class VerticalAlignmentEditor extends PropertyEditorSupport {

    public String getJavaInitializationString() {
	VerticalAlignment value = (VerticalAlignment) getValue();
	if (value.isTop())
	    return("Top");
	else if (value.isBottom())
	    return("Bottom");
	else
	    return("Center");
    }

    public String getAsText() {
	return getJavaInitializationString();
    }

    public void setAsText(String text) throws IllegalArgumentException{
	if (text.toLowerCase().equals("top")) 
            setValue(new VerticalAlignment(VerticalAlignment.ALIGN_TOP));
	else if (text.toLowerCase().equals("bottom")) 
            setValue(new VerticalAlignment(VerticalAlignment.ALIGN_BOTTOM));
	else if (text.toLowerCase().equals("center")) 
            setValue(new VerticalAlignment(VerticalAlignment.ALIGN_CENTER));
        else 
            throw new IllegalArgumentException(text);
    }

    public String[] getTags() {
        String result[] = { "Top", "Center", "Bottom" };
        return result;
    }

}

