package sieve.whiteboard;

import java.beans.*;
import java.awt.*;

/**
 * Overriding getPropertyDescriptors() to hide normal component properties.
 */
public class WhiteBoardShapeBeanInfo extends SimpleBeanInfo {

    public BeanDescriptor getBeanDescriptor() {
	BeanDescriptor bd = new BeanDescriptor(WhiteBoardShape.class);
	bd.setDisplayName("Whiteboard Component");
	return bd;
    }

    public PropertyDescriptor[] getPropertyDescriptors() {
	try {
	  PropertyDescriptor thickness = 
	    new PropertyDescriptor("lineThickness", WhiteBoardShape.class);
	  PropertyDescriptor fill = 
	    new PropertyDescriptor("fillColor", WhiteBoardShape.class);
	  PropertyDescriptor filled = 
	    new PropertyDescriptor("filled", WhiteBoardShape.class);
	  PropertyDescriptor line = 
	    new PropertyDescriptor("lineColor", WhiteBoardShape.class);

	  PropertyDescriptor[] descriptors = {line, thickness, filled, fill};
	  return descriptors;
	}
	catch (IntrospectionException e) {
	  throw new Error(e.toString());
	}
    }

}

