package sieve.workbench;

import java.beans.*;
import java.awt.*;

public class LinkProxy extends SimpleLink {
    private Workbench wb = null;
    private Link delegate = null;

    public LinkProxy(Workbench wb, WorkbenchComponent source) 
	throws LinkException {
	super(wb, source);
	this.wb = wb;
    }

    public Link getDelegate() {
	return delegate;
    }

    public void link(WorkbenchComponent source, WorkbenchComponent dest) 
        throws LinkException {
	Class srcClass = source.getModel().getClass();
        Class destClass = dest.getModel().getClass();

	LinkFactory lf = LinkFactory.getLinkFactory();
	Class[] options = lf.getLinkTypes(srcClass, destClass);

	try {
	    delegate = (Link) options[0].newInstance();
	    // System.out.println("Using instance of " + options[0]);
	    delegate.init(wb, source, dest, null);
	    Rectangle bounds = getView().getBounds();
	    wb.remove(getView());
	    wb.add(delegate.getView());
	    delegate.getView().setBounds(bounds);
	}
	catch(Exception e) {
	    e.printStackTrace();
	}

    }

    public void unlink(WorkbenchComponent source, WorkbenchComponent dest) {
	// System.err.println("LinkProxy got unlink!!");
    }

}

