
// Support for drawing a property value in a Canvas.

package sieve.workbench;

import java.awt.*;
import java.beans.*;

public class PropertyCanvas extends Canvas {

    public PropertyCanvas(Frame frame, PropertyEditor pe) {
	this.frame = frame;
	editor = pe;
    }

    public void paint(Graphics g) {
	Rectangle box = new Rectangle(2, 2, size().width, size().height);
	editor.paintValue(g, box);
    }

    public boolean handleEvent(Event evt) {
	if (evt.id == Event.MOUSE_DOWN && evt.target == this) {
	    if (frame == null) {
		frame = getParent();
	        while ((frame != null) && (! (frame instanceof Frame))) {
                    frame = frame.getParent();
                }
	    }
	    if (frame != null) {
	        int x = frame.location().x - 30;
	        int y = frame.location().y + 50;
	        new PropertyDialog((Frame)frame, editor, x, y);
	    }
	}
	return (false);
    }

    private Component frame;
    private PropertyEditor editor;
}
