
// Support for a PropertyEditor that uses text.

package sieve.workbench;

import java.awt.*;
import java.awt.event.*;
import java.beans.*;

public class PropertyText extends TextField implements ActionListener, KeyListener {
    private PropertyEditor editor;
    private boolean requireConfirm = false;

    public PropertyText (PropertyEditor pe) {
	this(pe, true);
    }

    public PropertyText (PropertyEditor pe, boolean requireConfirm) {
	super(pe.getAsText());
	this.requireConfirm = requireConfirm;
	editor = pe;
	if (requireConfirm)
	    addActionListener(this);
	addKeyListener(this);
    }

    public void repaint() {
	setText(editor.getAsText());
    }

    // We get an action event when the user presses Return or Enter in
    // the field.
    public void actionPerformed(ActionEvent e) {
	try {
	    editor.setAsText(getText());
	} catch (IllegalArgumentException ex) {
	    // Quietly ignore.
	}
	setForeground(Color.black);
    }

    public void keyTyped(KeyEvent e) {
	if (requireConfirm)
	    setForeground(Color.red);
	else {
	    try {
	    	editor.setAsText(getText());
	    } catch (IllegalArgumentException ex) {
	    	// Quietly ignore.
	    }
	}
    }
    public void keyPressed(KeyEvent e) { }
    public void keyReleased(KeyEvent e) { }


}


