package sieve.workbench;


/**
 * An abstraction of a unique identifier for Links, WorkbenchComponents,
 * and other potentially sharable things. Initially this will just be
 * a string, but eventually we will want something more efficient.
 * <I>Should this also have static methods for tracking these?</I>
 */
public class UniqueID implements java.io.Serializable {
    private String id = null;

    public UniqueID(Object obj) {
	String host = "";
	try {
	    host = java.net.InetAddress.getLocalHost().getHostName();
	}
	catch (Exception e) {}
	id = obj.getClass().getName() + " " + System.currentTimeMillis() 
	    + " " + host;
    }

	//*** this constructor caused conflicts ***
	//this constructor written to allow sieve.workbench.collab.ReplayController
	//to generate new UniqueID objects which contain the class name (may not be important,
	//could have made UniquID's from the old ones).
//    public UniqueID(String className) {
//		String host = "";
//		try {
//		    host = java.net.InetAddress.getLocalHost().getHostName();
//		}
//		catch (Exception e) {}
//		id = className + " " + System.currentTimeMillis() + " " + host;
 //  }

    
	public int hashCode() {
		return id.hashCode();
    }
 
	public boolean equals(Object obj) {
		if (obj instanceof UniqueID)
		    return id.equals(((UniqueID)obj).id);
		return false;
    }

    public String toString() {
		return id;
    }
}

