package sieve.workbench.collab;

import java.awt.*;
import sieve.workbench.*;
import sieve.workbench.event.*;
import vt.cs.widgets.RadarPane;

public class RadarPaneUpdater extends WorkbenchListenerAdapter {
    private RadarPane scroller = null;

    public RadarPaneUpdater(RadarPane scroller) {
	this.scroller = scroller;
    }

    private void reset() {
	Component c = scroller.getRadarView();
	if (c != null)
	    c.repaint();
    }

    /**
     * Called when a component is added to the workbench. Note that this
     * notification is not sent until the component has been completely
     * constructed.
     */
    public void componentAdded(WorkbenchComponentEvent e) {
	reset();
    }

    /**
     * Called when a component is removed from the workbench.
     */
    public void componentRemoved(WorkbenchComponentEvent e) {
	reset();
    }
 
    /**
     * Called when a component is edited.
     */
    public void componentEdited(WorkbenchComponentEvent e) {
	reset();
    }
 
    /**
     * Called when the bounds of a component are changed.
     */
    public void componentBoundsChanged(WorkbenchComponentEvent e) {
	reset();
    }

    /**
     * Called when a link is added.
     */
    public void linkAdded(LinkEvent e) {
	reset();
    }
 
    /**
     * Called when a link is removed.
     */
    public void linkRemoved(LinkEvent e) {
	reset();
    }


}

