package sieve.workbench.collab;

import java.util.*;

/**
 * Utility class for use by the WorkbenchManager to handle registration and 
 * notification of WorkbenchChannelListeners. 
 */
public class WorkbenchChannelListenerSupport {
    private WorkbenchChannelManager source = null;
    private Vector listeners = new Vector();

    public WorkbenchChannelListenerSupport(WorkbenchChannelManager source) {
	this.source = source;
    }

    public synchronized void addWorkbenchChannelListener(
	WorkbenchChannelListener l) {
	listeners.addElement(l);
    }

    public synchronized void removeWorkbenchChannelListener(
	WorkbenchChannelListener l) {
	listeners.removeElement(l);
    }

    public void channelAdded(String c) {
	Vector targets;
	synchronized(this) {
	    targets = (Vector)listeners.clone();
	}
	WorkbenchChannelEvent e = new WorkbenchChannelEvent(source, c);

	for (int i = 0; i < targets.size(); i++) {
	    ((WorkbenchChannelListener)targets.elementAt(i)).channelAdded(e);
	}
    }

    public void channelRemoved(String c) {
	Vector targets;
	synchronized(this) {
	    targets = (Vector)listeners.clone();
	}
	WorkbenchChannelEvent e = new WorkbenchChannelEvent(source, c);

	for (int i = 0; i < targets.size(); i++) {
	    ((WorkbenchChannelListener)targets.elementAt(i)).channelRemoved(e);
	}
    }
}

