package sieve.workbench.event;

import sieve.workbench.*;

/**
 * Event describing a tool change. See the ToolListener interface.
 */
public class ToolEvent extends java.util.EventObject {
    private Tool newTool = null;
    private Tool oldTool = null;
    private boolean sticky = false;
    private WorkbenchComponent createdComponent = null;

    public ToolEvent(Object source, Tool currentTool, Tool oldTool, 
	boolean sticky, WorkbenchComponent createdComponent) {
	super(source);
	this.newTool = currentTool;
	this.oldTool = oldTool;
	this.sticky = sticky;
	this.createdComponent = createdComponent;
    }

    public Tool getCurrentTool() {
	return newTool;
    }
    public Tool getOldTool() {
	return oldTool;
    }
    public boolean isToolRetained() {
	return sticky;
    }
    public WorkbenchComponent getCreatedComponent() {
	return createdComponent;
    }

}

