package sieve.workbench.event;


/**
 * Interface for classes which listen for tool events. These objects
 * may register themselves with the Workbench.
 */
public interface ToolListener extends java.util.EventListener {

    /**
     * Called when the current tool is changed.
     */
    public void toolChanged(ToolEvent e);

    /**
     * Called when the current tool is used to construct a new object.
     */
    public void toolUsed(ToolEvent e);

    /**
     * Called when the "sticky" state of the current tool is changed.
     */
    public void toolRetainedStateChanged(ToolEvent e);

}


