package sieve.workbench.event;
 
import sieve.workbench.*;
import java.beans.PropertyChangeEvent;

/**
 * A WorkbenchComponentEvent is passed to WorkbenchListener objects when 
 * something interesting happens to a WorkbenchComponent.
 */
public class WorkbenchComponentEvent extends java.util.EventObject {
    private WorkbenchComponent c = null;
    private EditEvent pce = null;

    public WorkbenchComponentEvent(Object source, WorkbenchComponent c) {
	super(source);
	this.c = c;
    }
    public WorkbenchComponentEvent(Object source, WorkbenchComponent c,
	EditEvent pce) {
	this(source, c);
	this.pce = pce;
    }

    public WorkbenchComponent getWorkbenchComponent() {
	return c;
    }

    public PropertyChangeEvent getPropertyChangeEvent() {
 	// Need to find and remove these someday...
	//
	// System.err.println("Someone's calling " + 
	//    "WorkbenchComponentEvent.getPropertyChangeEvent(). " +
	//    "This should be fixed...");
	// Thread.dumpStack();
	if (pce instanceof PropertyEditEvent) 
	    return ((PropertyEditEvent)pce).getPropertyChangeEvent();
	return null;
    }

    public EditEvent getEditEvent() {
	return pce;
    }

}

